# EWTL post-processed LDA time series
# 
# ********** DATA DESCRIPTION **********
# 
# 
# 
# 
# 
# ********** GENERAL INFORMATION **********
# EVALU [main project name]
# PROG [sub project name]
# WOTAN [wind tunnel facility]
# 1:225 [model - scale]
# 100.00 [zref - full scale [m]]
# 444.44 [zref - model scale [mm]]
#  5.40 [Uref - model [m/s]]
# 270.00 [approach flow direction []]
# 1.0 [Lref - model scale [m]]
# 225 [Lref - full scale [m]]
# # [utm zone]
# 
# 
# 
# 
# 
# 
# 
# 
# 
# 
# ********** FLOW MEASUREMENTS **********
# FL (LDA)[measurement type]
# 5 [number of columns]
# "I" "T*" "U/Uref" "V/Uref" "W/Uref" [labels]
# UV [measured components]
# 510.30 [measurement location X - model scale [mm]]
# 616.70 [measurement location Y - model scale [mm]]
# 400.00 [measurement location Z - model scale [mm]]
# 114.82 [measurement location X - full scale [m]]
# 138.76 [measurement location Y - full scale [m]]
# 90.00 [measurement location Z - full scale [m]]
# # [measurement location utm Easting [m]]
# # [measurement location utm Northing [m]]
# 0.034 0.029 [confidence intervall {U,V}/Uref[-]]
# 
# 
# 
# 
# 
# 
# 
# 
# 
# 
# ********** CONCENTRATION MEASUREMENTS **********
# # [measurement type]
# # [number of columns]
# # [labels]
# # [released gas]
# # [source strength [l/h]]
# # [release duration [s]]
# # [number of released puffs]
# # [number of detected puffs, which dosage exceeds the dosage threshold]
# # [discard threshold/minimum dosage - model scale [ppmvs] ]
# # [source location X - model scale [mm]]
# # [source location Y - model scale [mm]]
# # [source location Z - model scale [mm]]
# # [source location X - full scale [m]]
# # [source location Y - full scale [m]]
# # [source location Z - full scale [m]]
# # [source location utm Easting [m]]
# # [source location utm Northing [m]]
# # [measurement location X - model scale [mm]]
# # [measurement location Y - model scale [mm]]
# # [measurement location Z - model scale [mm]]
# # [measurement location X - full scale [m]]
# # [measurement location Y - full scale [m]]
# # [measurement location Z - full scale [m]]
# # [measurement location utm Easting [m]]
# # [measurement location utm Northing [m]]
# # [1E-6 * confidence intervall [-]]
# 
# 
# 
# 
# 
# 
# 
# 
# 10:15:58 [date of measurement]
# ********** END OF HEADER **********
VARIABLES= "I [-]" "T<sup>*</sup> [-]" "U/U<sub>ref</sub> [-]" "V/U<sub>ref</sub> [-]" "W/U<sub>ref</sub> [-]"
0   0.454618   0.6930   -0.1059   999.999
1   1.953630   0.6015   -0.0322   999.999
2   2.119633   0.8033   -0.1029   999.999
3   2.214207   0.6863   -0.0765   999.999
4   2.336633   0.8004   -0.1419   999.999
5   2.974962   0.8063   -0.2391   999.999
6   3.129036   0.6753   -0.0640   999.999
7   3.268850   0.6954   -0.0783   999.999
8   4.010205   1.0105   0.1108   999.999
9   4.329563   0.8761   -0.2125   999.999
10   4.559939   0.7107   -0.1255   999.999
11   5.088122   0.6228   -0.3205   999.999
12   5.143702   0.5858   -0.1729   999.999
13   5.203759   0.5889   -0.1293   999.999
14   5.341679   0.7124   0.0662   999.999
15   5.835345   0.5654   -0.0184   999.999
16   5.896802   0.5977   -0.0531   999.999
17   6.107267   0.6113   0.1238   999.999
18   6.219891   0.6607   -0.0889   999.999
19   6.221605   0.6550   -0.1026   999.999
20   6.692411   0.6295   0.1926   999.999
21   7.343200   1.0369   0.0407   999.999
22   8.291818   1.3088   0.1791   999.999
23   8.360525   1.3100   0.0453   999.999
24   8.378539   1.1821   -0.0610   999.999
25   8.500823   1.2775   0.0275   999.999
26   8.504701   1.2510   0.0236   999.999
27   8.874674   0.9857   -0.3079   999.999
28   9.152850   0.9838   0.0107   999.999
29   9.438520   0.9304   0.0238   999.999
30   9.621754   1.0870   -0.1337   999.999
31   9.702147   1.0938   -0.0730   999.999
32   9.830220   0.9749   -0.0875   999.999
33   9.873239   0.9915   -0.0842   999.999
34   10.124862   1.1455   -0.1440   999.999
35   10.564938   1.0975   -0.0635   999.999
36   10.581330   1.1039   0.0617   999.999
37   10.614351   1.0792   0.1923   999.999
38   10.727192   1.0137   -0.0172   999.999
39   11.568372   1.1695   0.2285   999.999
40   11.775603   1.1496   -0.0492   999.999
41   11.878509   1.0891   -0.1758   999.999
42   12.041712   1.1880   0.0667   999.999
43   12.373953   1.1953   0.0876   999.999
44   13.092306   1.2584   -0.0604   999.999
45   13.277672   1.2228   -0.0839   999.999
46   13.432501   1.2410   -0.0878   999.999
47   13.552330   1.0807   -0.0125   999.999
48   14.254650   0.9368   0.0929   999.999
49   14.877167   1.2244   0.3396   999.999
50   14.948822   1.2706   0.1932   999.999
51   15.263095   1.3285   0.0434   999.999
52   15.618909   1.0707   0.1509   999.999
53   15.723884   1.1408   0.0853   999.999
54   15.771085   0.8955   -0.1036   999.999
55   15.941169   0.9446   0.0907   999.999
56   16.765952   1.0651   -0.4236   999.999
57   16.808590   1.0871   -0.2712   999.999
58   16.816443   0.9304   -0.4106   999.999
59   17.001630   1.0197   0.2267   999.999
60   17.378700   1.0478   0.0205   999.999
61   17.919121   0.7944   -0.1653   999.999
62   17.969538   0.7952   -0.1784   999.999
63   18.183618   0.7586   -0.1398   999.999
64   18.286837   0.7468   -0.1308   999.999
65   18.965833   1.0630   -0.3066   999.999
66   18.973658   1.0605   -0.2672   999.999
67   19.104490   0.9205   -0.0599   999.999
68   19.344589   0.8966   -0.2665   999.999
69   19.810375   0.8963   -0.0349   999.999
70   19.999684   0.8876   0.0582   999.999
71   20.031212   0.8857   0.0635   999.999
72   20.054131   1.0007   -0.0118   999.999
73   20.442473   0.9114   -0.2528   999.999
74   20.466894   1.0207   -0.0451   999.999
75   20.777044   1.1275   -0.0201   999.999
76   20.842758   1.3108   -0.0295   999.999
77   20.951624   1.2072   -0.0390   999.999
78   21.691851   0.9878   0.1831   999.999
79   21.742631   0.8712   0.1973   999.999
80   21.754911   0.8487   0.1938   999.999
81   21.791625   0.8979   0.1377   999.999
82   21.953704   0.8360   0.0476   999.999
83   22.418430   0.8245   -0.1087   999.999
84   22.604322   1.1128   0.0181   999.999
85   22.679657   1.0461   0.0828   999.999
86   22.743311   1.0138   -0.0328   999.999
87   22.910502   1.3297   0.1339   999.999
88   23.167455   1.2635   0.0112   999.999
89   23.899925   1.2203   -0.1408   999.999
90   24.216580   0.8486   -0.0030   999.999
91   24.524077   0.9616   0.0367   999.999
92   24.611922   1.0645   0.0336   999.999
93   25.430722   0.7964   0.2408   999.999
94   25.687057   0.9082   0.1433   999.999
95   25.841642   0.7646   -0.0913   999.999
96   26.080682   0.9321   0.0405   999.999
97   27.300641   1.3440   -0.0992   999.999
98   27.421317   1.3261   -0.2663   999.999
99   27.441183   1.4482   -0.0725   999.999
