// LDA_ANALYSIS_2.1_func1
// created: 10-29-2009
// author:  RF
// last modification: 10-29-2009 

// This library contains functions only for lda measurements!

// contents:
// 01. lda_ts_detection
// 02. lda_data_init
// 03. lda_time_step_mean
// 04. lda_sample_and_hold
// 05. lda_statistic_parameters
// 06. lda_statistics_arith
// 07. lda_statistics_weight
// 08. lda_autocorrelation
// 09. lda_integral_scales
// 10. lda_spectrum
// 11. lda_wind_fluctuation





/******************************************************
* function    : lda_ts_detection                      *
*-----------------------------------------------------*
* task        : detecting the actual lda timeseries   *                         
* parameter   : no one                                *
* return value: no one                                *
******************************************************/
void lda_ts_detection()
{
    
        
        if(lda_ts_startnumber + lda_ts_index == 1){
            sprintf(lda_ts_inputfile, "%s.000001.bin", meas_code);
            fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
            if (fh==-1) {
                sprintf(lda_ts_inputfile, "%s.00001.bin", meas_code);
                fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                if (fh==-1) {
                    sprintf(lda_ts_inputfile, "%s.0001.bin", meas_code);
                    fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                    if (fh==-1) {
                        sprintf(lda_ts_inputfile, "%s.001.bin", meas_code);
                        fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                        if (fh==-1) {
                            sprintf(lda_ts_inputfile, "%s.01.bin", meas_code);
                            fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                        }
                    }
                }
            }
            strcpy(ts_string, "01");
        }
        else if(lda_ts_startnumber + lda_ts_index == 2){
                 sprintf(lda_ts_inputfile, "%s.000002.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00002.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0002.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.002.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.02.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "02");
        }
        else if(lda_ts_startnumber + lda_ts_index == 3){
                 sprintf(lda_ts_inputfile, "%s.000003.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00003.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0003.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.003.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.03.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "03");
        }
        else if(lda_ts_startnumber + lda_ts_index == 4){
                 sprintf(lda_ts_inputfile, "%s.000004.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00004.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0004.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.004.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.04.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "04");
        }
        else if(lda_ts_startnumber + lda_ts_index == 5){
                 sprintf(lda_ts_inputfile, "%s.000005.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00005.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0005.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.005.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.05.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "05");
        }
        else if(lda_ts_startnumber + lda_ts_index == 6){
                 sprintf(lda_ts_inputfile, "%s.000006.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00006.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0006.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.006.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.06.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "06");
        }
        else if(lda_ts_startnumber + lda_ts_index == 7){
                 sprintf(lda_ts_inputfile, "%s.000007.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00007.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0007.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.007.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.07.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "07");
        }
        else if(lda_ts_startnumber + lda_ts_index == 8){
                 sprintf(lda_ts_inputfile, "%s.000008.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00008.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0008.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.008.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.08.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "08");
        }
        else if(lda_ts_startnumber + lda_ts_index == 9){
                 sprintf(lda_ts_inputfile, "%s.000009.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00009.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0009.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.009.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.09.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "09");
        }
        else if(lda_ts_startnumber + lda_ts_index == 10){
                 sprintf(lda_ts_inputfile, "%s.000010.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00010.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0010.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.010.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.10.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "10");
        }
        else if(lda_ts_startnumber + lda_ts_index == 11){
                 sprintf(lda_ts_inputfile, "%s.000011.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00011.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0011.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.011.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.11.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "11");
        }
        else if(lda_ts_startnumber + lda_ts_index == 12){
                 sprintf(lda_ts_inputfile, "%s.000012.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00012.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0012.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.012.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.12.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "12");
        }
        else if(lda_ts_startnumber + lda_ts_index == 13){
                 sprintf(lda_ts_inputfile, "%s.000013.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00013.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0013.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.013.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.13.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         } 
                     }
                 }
                 strcpy(ts_string, "13");
        }
        else if(lda_ts_startnumber + lda_ts_index == 14){
                 sprintf(lda_ts_inputfile, "%s.000014.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00014.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0014.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.014.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.14.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "14");
        }
        else if(lda_ts_startnumber + lda_ts_index == 15){
                 sprintf(lda_ts_inputfile, "%s.000015.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00015.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0015.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.015.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                                 if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.15.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "15");
        }
        else if(lda_ts_startnumber + lda_ts_index == 16){
                 sprintf(lda_ts_inputfile, "%s.000016.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00016.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0016.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.016.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.16.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "16");
        }
        else if(lda_ts_startnumber + lda_ts_index == 17){
                 sprintf(lda_ts_inputfile, "%s.000017.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00017.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0017.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.017.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.17.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "17");
        }
        else if(lda_ts_startnumber + lda_ts_index == 18){
                 sprintf(lda_ts_inputfile, "%s.000018.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00018.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0018.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.018.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.18.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "18");
        }
        else if(lda_ts_startnumber + lda_ts_index == 19){
                 sprintf(lda_ts_inputfile, "%s.000019.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00019.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0019.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.019.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.19.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "19");
        }
        else if(lda_ts_startnumber + lda_ts_index == 20){
                 sprintf(lda_ts_inputfile, "%s.000020.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00020.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0020.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.020.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.20.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "20");
        }
        else if(lda_ts_startnumber + lda_ts_index == 21){
                 sprintf(lda_ts_inputfile, "%s.000021.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00021.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0021.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.021.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.21.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "21");
        }
        else if(lda_ts_startnumber + lda_ts_index == 22){
                 sprintf(lda_ts_inputfile, "%s.000022.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00022.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0022.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.022.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.22.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "22");
        }
        else if(lda_ts_startnumber + lda_ts_index == 23){
                 sprintf(lda_ts_inputfile, "%s.000023.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00023.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0023.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.023.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.23.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "23");
        }
        else if(lda_ts_startnumber + lda_ts_index == 24){
                 sprintf(lda_ts_inputfile, "%s.000024.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00024.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0024.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.024.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.24.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "24");
        }
        else if(lda_ts_startnumber + lda_ts_index == 25){
                 sprintf(lda_ts_inputfile, "%s.000025.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00025.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0025.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.025.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.25.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "25");
        }
        else if(lda_ts_startnumber + lda_ts_index == 26){
                 sprintf(lda_ts_inputfile, "%s.000026.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00026.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0026.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.026.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.26.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "26");
        }
        else if(lda_ts_startnumber + lda_ts_index == 27){
                 sprintf(lda_ts_inputfile, "%s.000027.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00027.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0027.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.027.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.27.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "27");
        }
        else if(lda_ts_startnumber + lda_ts_index == 28){
                 sprintf(lda_ts_inputfile, "%s.000028.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00028.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0028.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.028.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.28.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "28");
        }
        else if(lda_ts_startnumber + lda_ts_index == 29){
                 sprintf(lda_ts_inputfile, "%s.000029.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00029.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0029.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.029.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.29.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "29");
        }
        else if(lda_ts_startnumber + lda_ts_index == 30){
                 sprintf(lda_ts_inputfile, "%s.000030.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00030.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0030.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.030.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.30.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "30");
        }
        else if(lda_ts_startnumber + lda_ts_index == 31){
                 sprintf(lda_ts_inputfile, "%s.000031.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00031.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0031.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.031.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.31.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "31");
        }
        else if(lda_ts_startnumber + lda_ts_index == 32){
                 sprintf(lda_ts_inputfile, "%s.000032.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00032.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0032.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.032.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.32.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "32");
        }
        else if(lda_ts_startnumber + lda_ts_index == 33){
                 sprintf(lda_ts_inputfile, "%s.000033.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00033.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0033.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.033.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.33.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "33");
        }
        else if(lda_ts_startnumber + lda_ts_index == 34){
                 sprintf(lda_ts_inputfile, "%s.000034.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00034.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0034.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.034.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.34.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "34");
        }
        else if(lda_ts_startnumber + lda_ts_index == 35){
                 sprintf(lda_ts_inputfile, "%s.000035.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00035.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0035.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.035.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.35.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "35");
        }
        else if(lda_ts_startnumber + lda_ts_index == 36){
                 sprintf(lda_ts_inputfile, "%s.000036.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00036.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0036.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.036.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.36.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "36");
        } 
        else if(lda_ts_startnumber + lda_ts_index == 37){
                 sprintf(lda_ts_inputfile, "%s.000037.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00037.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0037.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.037.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.37.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "37");
        }
        else if(lda_ts_startnumber + lda_ts_index == 38){
                 sprintf(lda_ts_inputfile, "%s.000038.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00038.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0038.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.038.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.38.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "38");
        }
        else if(lda_ts_startnumber + lda_ts_index == 39){
                 sprintf(lda_ts_inputfile, "%s.000039.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00039.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0039.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.039.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.39.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "39");
        }
        else if(lda_ts_startnumber + lda_ts_index == 40){
                 sprintf(lda_ts_inputfile, "%s.000040.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00040.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0040.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.040.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.40.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "40");
        }
        else if(lda_ts_startnumber + lda_ts_index == 41){
                 sprintf(lda_ts_inputfile, "%s.000041.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00041.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0041.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.041.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.41.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "41");
        }
        else if(lda_ts_startnumber + lda_ts_index == 42){
                 sprintf(lda_ts_inputfile, "%s.000042.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00042.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0042.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.042.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.42.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "42");
        }
        else if(lda_ts_startnumber + lda_ts_index == 43){
                 sprintf(lda_ts_inputfile, "%s.000043.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if  (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00043.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                       if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0043.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                                if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.043.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                                  if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.43.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }              
                         }
                     }
                  }
                  strcpy(ts_string, "43");
        }
        else if(lda_ts_startnumber + lda_ts_index == 44){
                 sprintf(lda_ts_inputfile, "%s.000044.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00044.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0044.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.044.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.44.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "44");
        }
        else if(lda_ts_startnumber + lda_ts_index == 45){
                 sprintf(lda_ts_inputfile, "%s.000045.bin", meas_code);
                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                 if (fh==-1) {
                     sprintf(lda_ts_inputfile, "%s.00045.bin", meas_code);
                     fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                     if (fh==-1) {
                         sprintf(lda_ts_inputfile, "%s.0045.bin", meas_code);
                         fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                         if (fh==-1) {
                             sprintf(lda_ts_inputfile, "%s.045.bin", meas_code);
                             fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             if (fh==-1) {
                                 sprintf(lda_ts_inputfile, "%s.45.bin", meas_code);
                                 fh = open(lda_ts_inputfile,_O_RDONLY|_O_BINARY|_O_TEXT);
                             }
                         }
                     }
                 }
                 strcpy(ts_string, "45");
        }
        else{
            printf("\n number of timeseries too high!\n");
            exit(6);
        }
    //}  
}







/******************************************************
* function    : quality_flag_function                 *
*-----------------------------------------------------*
* task        : to furnish the timeseries with a      *
*               quality flag                          *
* parameter   : no one                                *
* return value: no one                                *
******************************************************/
void quality_flag_function()
{
    if((atof(z_position)) >= (1.5 * rough_el_height) && ((atof(z_position)/1000.)*model_scale) <= prandtl_layer_min) { 
            quality_flag = 0;
    }
    if((atof(z_position)) < (1.5 * rough_el_height)) {
            quality_flag = 1;
    }
    if(((atof(z_position)/1000.)*model_scale) > prandtl_layer_min && ((atof(z_position)/1000.)*model_scale) <= prandtl_layer_max) {
            quality_flag = 2;
    }
    if(((atof(z_position)/1000.)*model_scale) > prandtl_layer_max) {
            quality_flag = 3;
    }       
}






/******************************************************
* function    : lda_data_init                         *
*-----------------------------------------------------*
* task        : initializing data arrays              *
* parameter   : no one                                *
* return value: no one                                *
******************************************************/
void lda_data_init()
{
    for(i1=0; i1<BLOCK; i1++) {
        for(i2=0; i2<SIZE; i2++) {
            data_raw[i1][i2]     = 0.0;
            data_raw_out[i1][i2] = 0.0;
            data_resam[i1][i2]   = 0.0;
        }    
    }    
}





/********************************************************
* function    : lda_outliers_subst                      *
*-------------------------------------------------------*
* task        : substituting outliers by previous value *
* parameter   : no one                                  *
* return value: no one                                  *
********************************************************/
void lda_outliers_subst()
{
    double sum_comp1, sum_comp2, mean_comp1, mean_comp2;
    double sum_comp1_diff_square, sum_comp2_diff_square;
    double std_dev_comp1, std_dev_comp2;
    int    out_count_comp1, out_count_comp2;
    
    
    sum_comp1              = 0.0;
    sum_comp2              = 0.0;
    sum_comp1_diff_square  = 0.0;
    sum_comp2_diff_square  = 0.0;
    std_dev_comp1          = 0.0;
    std_dev_comp2          = 0.0;

    j = 0;
    do {
        sum_comp1    = sum_comp1    + data_raw[2][j];
        sum_comp2    = sum_comp2    + data_raw[3][j];
        j++;
    } while(j < data_count[0]);

    mean_comp1 = sum_comp1/j;
    mean_comp2 = sum_comp2/j;

    j = 0;
    do {
        sum_comp1_diff_square = sum_comp1_diff_square + pow((data_raw[2][j] - mean_comp1), 2.0);
        sum_comp2_diff_square = sum_comp2_diff_square + pow((data_raw[3][j] - mean_comp2), 2.0);
        j++;
    } while(j < data_count[0]);

    
    std_dev_comp1 = sqrt( fabs( sum_comp1_diff_square/(j-1) ) );
    std_dev_comp2 = sqrt( fabs( sum_comp2_diff_square/(j-1) ) );

    
    j = 0;
    out_count_comp1 = 0;
    out_count_comp2 = 0;
    do {
        out_detec[j] = 0;
        if(data_raw[2][j] <= mean_comp1-(SIGMAF*std_dev_comp1)
           || data_raw[2][j] >= mean_comp1+(SIGMAF*std_dev_comp1))
           {
               if(j==0)
               {
                   //data_raw[2][j] = mean_comp1;
                   out_count_comp1++;
               }
               if(j!=0)
               {
                   //data_raw[2][j] = data_raw[2][j-1];
                   out_count_comp1++;
               }
               out_detec[j] = 1;
        }
        if(data_raw[3][j] <= mean_comp2-(SIGMAF*std_dev_comp2)
           || data_raw[3][j] >= mean_comp2+(SIGMAF*std_dev_comp2))
           {
               if(j==0)
               {
                   data_raw[3][j] = mean_comp2;
                   out_count_comp2++;
               }
               if(j!=0)
               {
                   data_raw[3][j] = data_raw[3][j-1];
                   out_count_comp2++;
               }
               out_detec[j] = 1;
        }
        
        j++;
    } while(j < data_count[0]);

    printf(" outliers (%3.1lf-sigma):\n", SIGMAF);
    printf("          in 1st component: %i  (%4.3lf %%)\n", out_count_comp1,
                                                        ((double) out_count_comp1/data_count[0])*100.0);
    printf("          in 2nd component: %i  (%4.3lf %%)\n", out_count_comp2,
                                                        ((double) out_count_comp2/data_count[0])*100.0);

    j = 0;
    out_delete_index = 0;
    do {
        if(out_detec[j] == 0) {
            data_raw_out[0][out_delete_index] = data_raw[0][j];
            data_raw_out[1][out_delete_index] = data_raw[1][j];
            data_raw_out[2][out_delete_index] = data_raw[2][j];
            data_raw_out[3][out_delete_index] = data_raw[3][j];
            out_delete_index++;
        }
        j++;
    } while(j < data_count[0]);
    
    
    data_count[0] = out_delete_index;

    for(i1=0; i1<BLOCK; i1++) {
        for(i2=0; i2<SIZE; i2++) {
            data_raw[i1][i2]     = 0.0;
        }    
    }

    j = 0;
    do {
        data_raw[0][j] = data_raw_out[0][j];
        data_raw[1][j] = data_raw_out[1][j];
        data_raw[2][j] = data_raw_out[2][j];
        data_raw[3][j] = data_raw_out[3][j];
        j++;
    } while(j < data_count[0]);    



    if(output_outlier_subst == 1) { 
        sprintf(out_file_outsubst, "OUTLIERS_deleted\\%s_%s_%s_%s_%s%s_%s_%s_%s_%s_EWTL.out_del",
                str_maincamp, str_subcamp, str_wt, str_meastype, str_comp1, str_comp2, str_instnumb, str_winddir, meas_number_string, ts_string);
        fh = fopen(out_file_outsubst, "w");
        fprintf(fh, "Variables = \"i [-]\" \"AT [ms]\" \"TT [us]\" \"%s [m/s]\" \"%s [m/s]\"\n",
                    str_comp1, str_comp2);
        j = 0;
        do {
            fprintf(fh, "%i   %6.3lf   %2.1lf     %4.3lf   %4.3lf\n", j+1, data_raw[0][j]*1000., data_raw[1][j]*1000000., data_raw[2][j], data_raw[3][j]);
            j++;
        } while(j < data_count[0]);
        close(fh);
    }                                                       
}






/********************************************************
* function    : lda_histogram                           *
*-------------------------------------------------------*
* task        : calculating frequency distributions     *
*               of the measured wind speeds             *
* parameter   : no one                                  *
* return value: no one                                  *
********************************************************/
void lda_histograms()
{
    double min_comp1, min_comp2, max_comp1, max_comp2;
    int    n, classcount, classnumber, classnumber_help;
    double classwidth_comp1, classwidth_comp2;
    double min_class_comp1, min_class_comp2;
    double max_class_comp1, max_class_comp2;
    double freq_comp1_norm, freq_comp2_norm;
    int    freq_comp1, freq_comp2;

    

    if (raw_filename_output == 0) {
        sprintf(out_file_histograms, "FLUC_speed\\%s_%s_%s_%s_%s%s_%s_%s_%s_%s_EWTL.hist",
                str_maincamp, str_subcamp, str_wt, str_meastype, str_comp1, str_comp2, str_instnumb, str_winddir, meas_number_string, ts_string);
    }
    if (raw_filename_output == 1) {
        sprintf(out_file_histograms, "FLUC_speed\\%s_%s_EWTL.hist", meas_code, ts_string);
    }
    fh = fopen(out_file_histograms, "w");
    

    
    fprintf(fh, "# EWTL fluctuations of wind speed derived from LDA time series\n");
    fprintf(fh, "# \n");
    fprintf(fh, "# ********** DATA DESCRIPTION **********\n");
    fprintf(fh, "# \n# \n# \n# \n# \n");
    fprintf(fh, "# ********** GENERAL INFORMATION **********\n");
    fprintf(fh, "# %s [main project name]\n", str_maincamp);
    fprintf(fh, "# %s [sub project name]\n", str_subcamp);
    if (strcmp(str_wt, BLASIUS) == 0) {
        fprintf(fh, "# BLASIUS [wind tunnel facility]\n");
    }
    else if (strcmp(str_wt, WOTAN) == 0) {
        fprintf(fh, "# WOTAN [wind tunnel facility]\n");
    }
    fprintf(fh, "# 1:%i [model - scale]\n", model_scale);
    fprintf(fh, "# %5.2lf [zref - full scale [m]]\n", ref_height*model_scale);
    fprintf(fh, "# %5.2lf [zref - model scale [mm]]\n", ref_height*1000.);
    fprintf(fh, "# %5.2lf [Uref - model [m/s]]\n", u_ref*lda_scale_factor);
    fprintf(fh, "# %5.2lf [approach flow direction []]\n", atof(str_winddir)/10.);
    fprintf(fh, "# 1.0 [Lref - model scale [m]]\n");
    fprintf(fh, "# %i [Lref - full scale [m]]\n", model_scale);
    fprintf(fh, "# # [utm zone]\n");

    if(quality_flag == 0) { 
        fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 1) {
        fprintf(fh, "# \n# ATTENTION: in case of an approach flow measurement,\n");
        fprintf(fh, "#            timeseries is not adequate for boundary layer characterization!\n");
        fprintf(fh, "#            (position below 1.5 height of roughness elements)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 2) {
        fprintf(fh, "# \n# ATTENTION: handle with care,\n");
        fprintf(fh, "#            flow might be out of the prandtl layer!\n");
        fprintf(fh, "#            (position within ]100 m; 150 m] height in full scale)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 3) {
        fprintf(fh, "# \n# ATTENTION: flow is out of the model area (prandtl layer)!\n");
        fprintf(fh, "#            (position above 150 m height in full scale)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n");
    }

    fprintf(fh, "# ********** FLOW MEASUREMENTS **********\n");
    fprintf(fh, "# %s [measurement type]\n", str_meastype);
    fprintf(fh, "# 2 [number of columns]\n");
    fprintf(fh, "# \"f*z/Umean\" \"f*SUU(f,z)/sigmaU^2\" [labels]\n");
    fprintf(fh, "# %s%s [measured components]\n", str_comp1, str_comp2);
    fprintf(fh, "# %5.2lf [measurement location X - model scale [mm]]\n", atof(x_position));  
    fprintf(fh, "# %5.2lf [measurement location Y - model scale [mm]]\n", atof(y_position));  
    fprintf(fh, "# %5.2lf [measurement location Z - model scale [mm]]\n", atof(z_position));  
    fprintf(fh, "# %5.2lf [measurement location X - full scale [m]]\n", (atof(x_position)/1000.)*model_scale);  
    fprintf(fh, "# %5.2lf [measurement location Y - full scale [m]]\n", (atof(y_position)/1000.)*model_scale);  
    fprintf(fh, "# %5.2lf [measurement location Z - full scale [m]]\n", (atof(z_position)/1000.)*model_scale);
    fprintf(fh, "# # [measurement location utm Easting [m]]\n");
    fprintf(fh, "# # [measurement location utm Northing [m]]\n");
    if (strcmp(str_comp1, U_WIND) == 0 && strcmp(str_comp2, V_WIND) == 0) {   
            fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {U,V}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }
    if (strcmp(str_comp1, U_WIND) == 0 && strcmp(str_comp2, W_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {U,W}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }
    if (strcmp(str_comp1, V_WIND) == 0 && strcmp(str_comp2, W_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {V,W}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }     
    fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n# \n");

    fprintf(fh, "# ********** CONCENTRATION MEASUREMENTS **********\n");
    fprintf(fh, "# # [measurement type]\n");
    fprintf(fh, "# # [number of columns]\n");
    fprintf(fh, "# # [labels]\n");
    fprintf(fh, "# # [released gas]\n");
    fprintf(fh, "# # [source strength [l/h]]\n");
    fprintf(fh, "# # [release duration [s]]\n");
    fprintf(fh, "# # [number of released puffs]\n");
    fprintf(fh, "# # [number of detected puffs, which dosage exceeds the dosage threshold]\n");
    fprintf(fh, "# # [discard threshold/minimum dosage - model scale [ppmvs] ]\n");
    fprintf(fh, "# # [source location X - model scale [mm]]\n");
    fprintf(fh, "# # [source location Y - model scale [mm]]\n");
    fprintf(fh, "# # [source location Z - model scale [mm]]\n");
    fprintf(fh, "# # [source location X - full scale [m]]\n");
    fprintf(fh, "# # [source location Y - full scale [m]]\n");
    fprintf(fh, "# # [source location Z - full scale [m]]\n");
    fprintf(fh, "# # [source location utm Easting [m]]\n");
    fprintf(fh, "# # [source location utm Northing [m]]\n");
    fprintf(fh, "# # [measurement location X - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location Y - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location Z - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location X - full scale [m]]\n");
    fprintf(fh, "# # [measurement location Y - full scale [m]]\n");
    fprintf(fh, "# # [measurement location Z - full scale [m]]\n");
    fprintf(fh, "# # [measurement location utm Easting [m]]\n");
    fprintf(fh, "# # [measurement location utm Northing [m]]\n");
    fprintf(fh, "# # [1E-6 * confidence intervall [-]]\n");

    fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n");

    fprintf(fh, "# %s [date of measurement]\n", time_stamp);
    fprintf(fh, "# ********** END OF HEADER **********\n");    
    

    
      
    fprintf(fh, "Variables = \"classnumber [-]\" \"%s/U<sub>ref</sub> [-]\" \"%s/U<sub>ref</sub> [-]\" \"occurrence %s/U<sub>ref</sub> (abs) [-]\" \"occurrence %s/U<sub>ref</sub> (abs) [-]\" \"occurrence %s/U<sub>ref</sub> (norm) [-]\" \"occurrence %s/U<sub>ref</sub> (norm) [-]\"\n",
                str_comp1, str_comp2, str_comp1, str_comp2, str_comp1, str_comp2);
    if (raw_filename_output == 0) {            
        fprintf(fh, "ZONE T = \"%s_%s_%s_%s_%s_%s_%s_%s_%s_%i\"\n",
        str_maincamp, str_subcamp, str_wt, str_meastype, str_comp1, str_comp2, str_instnumb, str_winddir, meas_number_string, lda_ts_startnumber + lda_ts_index);
    }
    if (raw_filename_output == 1) {            
        fprintf(fh, "ZONE T = \"%s_%s\"\n", meas_code, ts_string);
    }




    

    n = (data_count[0]/2) * 2.0;

    if(classnumber_speed <= 0) {
        classnumber      = (int) (1 + (log10(n)/log10(2.0)));
    }
    if(classnumber_speed > 0) {
        classnumber      = classnumber_speed;
    }
    
    classnumber_help = (classnumber - 1) * 2;

    

    j = 0;
    min_comp1 =  100000.0;
    min_comp2 =  100000.0;
    max_comp1 = -100000.0;
    max_comp2 = -100000.0;

    do {
        if(data_raw[2][j]/u_ref_sc < min_comp1) {
            min_comp1 = data_raw[2][j]/u_ref_sc;
        }
        if(data_raw[3][j]/u_ref_sc < min_comp2) {
            min_comp2 = data_raw[3][j]/u_ref_sc;
        }
        if(data_raw[2][j]/u_ref_sc > max_comp1) {
            max_comp1 = data_raw[2][j]/u_ref_sc;
        }
        if(data_raw[3][j]/u_ref_sc > max_comp2) {
            max_comp2 = data_raw[3][j]/u_ref_sc;
        }
        j++;
    } while(j < data_count[0]);

    classwidth_comp1 = ((max_comp1 - min_comp1)/classnumber_help) * 2.0;
    classwidth_comp2 = ((max_comp2 - min_comp2)/classnumber_help) * 2.0;
    

    classcount = 0;

    min_class_comp1 = min_comp1 - (classwidth_comp1/2.0);
    min_class_comp2 = min_comp2 - (classwidth_comp2/2.0);
    max_class_comp1 = min_comp1 + (classwidth_comp1/2.0);
    max_class_comp2 = min_comp2 + (classwidth_comp2/2.0);

    do {
        freq_comp1 = 0;
        freq_comp2 = 0;
        freq_comp1_norm = 0.;
        freq_comp2_norm = 0.;
        j = 0;
        do {
            if(min_class_comp1 < data_raw[2][j]/u_ref_sc
               && data_raw[2][j]/u_ref_sc <= max_class_comp1) {
                freq_comp1++;
                freq_comp1_norm = freq_comp1_norm + (1./data_count[0]);
            }
            if(min_class_comp2 < data_raw[3][j]/u_ref_sc
               && data_raw[3][j]/u_ref_sc <= max_class_comp2) {
                freq_comp2++;
                freq_comp2_norm = freq_comp2_norm + (1./data_count[0]);
            }
            j++;
        } while(j < data_count[0]);

        
        fprintf(fh, "%i   %5.4lf  %5.4lf   %i  %i   %5.4lf  %5.4lf\n", classcount+1,
                                                                       min_class_comp1+(classwidth_comp1/2.0),
                                                                       min_class_comp2+(classwidth_comp2/2.0),
                                                                       freq_comp1, freq_comp2,
                                                                       freq_comp1_norm,
                                                                       freq_comp2_norm);
                                                              
        
        min_class_comp1 = min_class_comp1 + classwidth_comp1;
        min_class_comp2 = min_class_comp2 + classwidth_comp2;
        max_class_comp1 = min_class_comp1 + classwidth_comp1;
        max_class_comp2 = min_class_comp2 + classwidth_comp2;
        classcount++;
    } while(classcount < classnumber);
    
    close(fh);

}

    

    






/******************************************************
* function    : lda_time_step_mean                    *
*-----------------------------------------------------*
* task        : calculating mean time step            *
* parameter   : no one                                *
* return value: no one                                *
******************************************************/
void lda_time_step_mean()
{
    time_step_mean = (data_raw[0][data_count[0]-1] - data_raw[0][0])/data_count[0];
    data_rate_mean = 1./time_step_mean;

    data_rate_mean = floor(data_rate_mean) * 1.0;
    time_step_mean = 1./data_rate_mean;
    printf(" number of samples: %i\n", data_count[0]);
    printf(" mean data rate: %5.0lf Hz\n", data_rate_mean);
}




/************************************************************
* function    : lda_sample_and_hold                         *
*-----------------------------------------------------------*
* task        : constructing an equidistant time series     *
*               for two data arrays                         *               
* parameter   : no one                                      *
* return value: no one                                      *
************************************************************/
void lda_sample_and_hold()
{
    j = 0;
    k = 0;
    data_count_resam = 0;

    do {   
         data_resam[0][k] = data_raw[0][0] + (k * time_step_mean);
         
         if(data_resam[0][k] == data_raw[0][j]) {
             data_resam[1][k] = data_raw[1][j];
             data_resam[2][k] = data_raw[2][j];
             data_resam[3][k] = data_raw[3][j];
             k++;
             j++;
         }
         else
            if(data_resam[0][k] > data_raw[0][j]) {
                do { 
                    data_resam[1][k] = data_raw[1][j];
                    data_resam[2][k] = data_raw[2][j];
                    data_resam[3][k] = data_raw[3][j];
                    j++;
                } while(data_resam[0][k] > data_raw[0][j] && j < data_count[0]);
            }    
         else
             if(data_resam[0][k] < data_raw[0][j]) {
                do {
                    data_resam[1][k] = data_raw[1][j-1];
                    data_resam[2][k] = data_raw[2][j-1];
                    data_resam[3][k] = data_raw[3][j-1];
                    k++;
                    data_resam[0][k] = data_raw[0][0] + (k * time_step_mean);
                } while(data_resam[0][k] < data_raw[0][j]);
                j++;
             }      
    } while(j < data_count[0]);
      
    data_count_resam = k;

    k = 0;
    sum_data_resam_2 = 0.;
    sum_data_resam_3 = 0.;
    do {
        sum_data_resam_2 = sum_data_resam_2 + data_resam[2][k];
        sum_data_resam_3 = sum_data_resam_3 + data_resam[3][k];
        k++;
    } while(k <= data_count_resam);

    mean_data_resam_2 = sum_data_resam_2/(data_count_resam + 1);
    mean_data_resam_3 = sum_data_resam_3/(data_count_resam + 1);
}






/******************************************************
* function    : lda_statistic_parameters              *
*-----------------------------------------------------*
* task        : calculating statistic parameters for  *
*               raw and resampled data                *                        
* parameter   : no one                                *
* return value: no one                                *
******************************************************/   
void lda_statistic_parameters()
{
    lda_statistics_arith(data_raw, data_arrays_number, data_count[0], 2, 3);
    
    data_raw_comp1_mean_arith          = mean_x[2];
    data_raw_comp1_rms_arith           = rms_x[2];
    data_raw_comp1_skew_arith          = skew_x[2];
    data_raw_comp1_flat_arith          = flat_x[2];
    data_raw_comp1_turb_arith          = turb_x[2];
    data_raw_comp1_mean_conf_arith     = conf_x[2];
    data_raw_comp1_rms_conf_arith      = conf_rms_x[2];
    
    data_raw_comp2_mean_arith          = mean_x[3];
    data_raw_comp2_rms_arith           = rms_x[3];
    data_raw_comp2_skew_arith          = skew_x[3];
    data_raw_comp2_flat_arith          = flat_x[3];
    data_raw_comp2_turb_arith          = turb_x[3];
    data_raw_comp2_mean_conf_arith     = conf_x[3];
    data_raw_comp2_rms_conf_arith      = conf_rms_x[3];
    
    data_raw_comp12_covar_arith        = covar_xy;
    data_raw_comp12_rms_covar_arith    = rms_covar_xy;
    data_raw_comp12_conf_covar_arith   = conf_covar_xy;

    
}




/************************************************************
* function    : lda_statistics_arith                        *
*-----------------------------------------------------------*
* task        : calculating arithmetic mean, standard       *
*               deviation, skewness, and kurtosis of data   *
*               distributions                               *               
* parameter   : data matrix, count1, count2                 *
* return value: no one                                      *
************************************************************/

void lda_statistics_arith(double matrix[][SIZE], int count1, int count2,
                  int number1, int number2)
{
    double lgF, F;
    
    for (i = 0; i < count1; i++)
    {
        sum_x[i]      = 0.;
        sum_x2[i]     = 0.;
        mean_x[i]     = 0.;
        rms_x[i]      = 0.;
        turb_x[i]     = 0.;
        conf_x[i]     = 0.;
        conf_rms_x[i] = 0.;
        
        for (j = 0; j < count2; j++)
        {
            sum_x[i]  = sum_x[i]  + matrix[i][j];
        }
        mean_x[i]  = sum_x[i]/j;
        
        for (j = 0; j < count2; j++)
        {
            sum_x2[i] = sum_x2[i] + pow(matrix[i][j]-mean_x[i], 2.);
        }
        rms_x[i]      = sqrt((1./j)*sum_x2[i]);


        if(confidence_interval == 90.0) {
            conf_x[i]     = 1.645 * (rms_x[i]/sqrt(j));  // 90%-Bereich -> 1.645
        }
        if(confidence_interval == 95.0) {
            conf_x[i]     = 1.96 * (rms_x[i]/sqrt(j));  // 95%-Bereich -> 1.96
        }
        if(confidence_interval == 99.0) {
            conf_x[i]     = 2.576 * (rms_x[i]/sqrt(j));  // 99%-Bereich -> 2.576
        }

        
        lgF           = 1.7023/sqrt(data_count[0] - 1.14);  // 95%-Bereich -> 1.7023 und 1.14 (Formel vereinfacht, sie L. Sachs S. 221)
        F             = pow(10.,lgF);
        conf_rms_x[i] = 0.5 * ( (rms_x[i]*sqrt(F)) - (rms_x[i]/sqrt(F)) );

        if (i >= 2) {
            turb_x[i]  = 100. * rms_x[i]/mean_x[2];
        }    
        
        sum_x_x2[i] = 0.;
        sum_x_x3[i] = 0.;
        sum_x_x4[i] = 0.;
        skew_x[i]   = 0.;
        flat_x[i]   = 0.;
        
        for (j = 0; j < count2; j++)
        {
            sum_x_x2[i] = sum_x_x2[i] + pow(matrix[i][j] - mean_x[i], 2.);
            sum_x_x3[i] = sum_x_x3[i] + pow(matrix[i][j] - mean_x[i], 3.);
            sum_x_x4[i] = sum_x_x4[i] + pow(matrix[i][j] - mean_x[i], 4.);
        }
        skew_x[i] = sqrt(j)*sum_x_x3[i]/pow(sum_x_x2[i], 1.5);
        flat_x[i] = (j*sum_x_x4[i]/pow(sum_x_x2[i], 2.));
    }

    sum_xy        = 0.;
    sum_xy2       = 0.;
    covar_xy      = 0.;
    rms_covar_xy  = 0.;
    conf_covar_xy = 0.;
        
    for (j = 0; j < count2; j++)
    {
        sum_xy = sum_xy + ((matrix[number1][j] - mean_x[number1])*(matrix[number2][j] - mean_x[number2]));
    }    

    covar_xy     = sum_xy/j;

    for (j = 0; j < count2; j++)
    {
        sum_xy2 = sum_xy2 + pow(((matrix[number1][j] - mean_x[number1])*(matrix[number2][j] - mean_x[number2])) - covar_xy, 2.);
    }
            
    rms_covar_xy  = sqrt((1./j)*sum_xy2);


    if(confidence_interval == 90.0) {
        conf_covar_xy = 1.645 * (rms_covar_xy/sqrt(j));  // 90%-Bereich -> 1.645
    }
    if(confidence_interval == 95.0) {
        conf_covar_xy = 1.96 * (rms_covar_xy/sqrt(j));  // 95%-Bereich -> 1.96
    }
    if(confidence_interval == 99.0) {
        conf_covar_xy = 2.576 * (rms_covar_xy/sqrt(j));  // 99%-Bereich -> 2.576
    }
    
}





/************************************************************
* function    : lda_statistics_weight                       *
*-----------------------------------------------------------*
* task        : calculating arithmetic mean, standard       *
*               deviation, skewness, and kurtosis of data   *
*               distributions                               *               
* parameter   : data matrix, count1, count2                 *
* return value: no one                                      *
************************************************************/

void lda_statistics_weight(double matrix[][SIZE], int count1, int count2,
                  int number1, int number2)
{
    sum_x[1] = 0.;
    for (j = 0; j < count2; j++)
    {
        sum_x[1]   = sum_x[1] + matrix[1][j];
    }
    sum_weight = sum_x[1];
    
        
    for (i = 0; i < count1; i++)
    {
        sum_x[i]   = 0.;
        sum_x2[i]  = 0.;
        mean_x[i]  = 0.;
        rms_x[i]   = 0.;
        turb_x[i]  = 0.;
        
        for (j = 0; j < count2; j++)
        {
            sum_x[i]  = sum_x[i]  + (matrix[1][j]/sum_weight)*matrix[i][j];
        }
        mean_x[i]  = sum_x[i];
        
        for (j = 0; j < count2; j++)
        {
            sum_x2[i] = sum_x2[i] + (matrix[1][j]/sum_weight)*pow(matrix[i][j]-mean_x[i], 2.);
        }
        rms_x[i]   = sqrt(sum_x2[i]);
        conf_x[i]  = 1.96 * (rms_x[i]/sqrt(j));

        if (i >= 2) {
            turb_x[i]  = 100. * rms_x[i]/mean_x[2];
        }

        sum_x_x2[i] = 0.;
        sum_x_x3[i] = 0.;
        sum_x_x4[i] = 0.;
        skew_x[i]   = 0.;
        flat_x[i]   = 0.;
        
        for (j = 0; j < count2; j++)
        {
            sum_x_x2[i] = sum_x_x2[i] + pow(matrix[i][j] - mean_x[i], 2.);
            sum_x_x3[i] = sum_x_x3[i] + pow(matrix[i][j] - mean_x[i], 3.);
            sum_x_x4[i] = sum_x_x4[i] + pow(matrix[i][j] - mean_x[i], 4.);
        }
        skew_x[i] = sqrt(j)*sum_x_x3[i]/pow(sum_x_x2[i], 1.5);
        flat_x[i] = (j*sum_x_x4[i]/pow(sum_x_x2[i], 2.));
    }

    sum_xy = 0.;
        
    for (j = 0; j < count2; j++)
    {
        sum_xy = sum_xy + (matrix[1][j]/sum_weight)*((matrix[number1][j] - mean_x[number1])*(matrix[number2][j] - mean_x[number2]));
    }    
    covar_xy = sum_xy;
}






/************************************************************
* function    : lda_autocorrelation                         *
*-----------------------------------------------------------*
* task        : proceeding the autocorrelation of a time    *
*               series                                      *               
* parameter   : array                                       *
* return value: no one                                      *
************************************************************/

void lda_autocorrelation(double array[][SIZE], int count, int number, int lag_step, char component)
{
    i = 0;
    j = -1*lag_step;
    RAA[j] = 2.0;
        
    do {
        
        j=j+lag_step;

        RAA[j]  = 0.;
        sum_Ak  = 0.;
        sum_Akj = 0.;
        
        for (k = 0; k <= count-j-1; k++)
        {
            sum_Ak  = sum_Ak  + array[number][k];
            sum_Akj = sum_Akj + array[number][k+j];
        }

        Ak_mean  = sum_Ak/(count-j);
        Akj_mean = sum_Akj/(count-j);

        sum_Akkkjkj = 0.;
        sum_Akk     = 0.;
        sum_Akjkj   = 0.;
        
        for (k = 0; k <= count-j-1; k++)
        {
            sum_Akkkjkj = sum_Akkkjkj + ((array[number][k]-Ak_mean)*(array[number][k+j]-Akj_mean));
            sum_Akk     = sum_Akk     + pow(array[number][k]-Ak_mean, 2.0);
            sum_Akjkj   = sum_Akjkj   + pow(array[number][k+j]-Akj_mean, 2.0);
        }

        RAA[j] = sum_Akkkjkj/(sqrt(sum_Akk)*sqrt(sum_Akjkj));
        

        if(output_autocorrelation == 1 && RAA[j] <= RAA[j-1]) {  
            lda_open_write_file_output_autocorrelation(1);
        }

         i++;
    } while(RAA[j] - RAA[j-1] < 0 && RAA[j] > 0.0);
    
    
    if(RAA[j] > 0.0) {
        
        jj = 0;
        sum_jj   = 0.;
        sum_RAA    = 0.;
        sum_jjRAA = 0.;
        sum_jj2  = 0.;
    
        do {
            sum_jj    = sum_jj    + jj;
            sum_RAA   = sum_RAA   + log(RAA[jj]);
            sum_jjRAA = sum_jjRAA + (jj * log(RAA[jj]));
            sum_jj2   = sum_jj2   + pow(jj, 2.0);
            jj++;
        } while(jj <= j-1);

        mean_jj  = sum_jj/jj;
        mean_RAA = sum_RAA/jj;
    
        extrapolation = ((sum_jjRAA - (jj*mean_jj*mean_RAA))/(sum_jj2 - (jj*pow(mean_jj, 2.0))));
        
        j = j-1;
        do {
            j=j+lag_step;

            RAA[j] = log(RAA[j-1]) + extrapolation;

            RAA[j] = exp(RAA[j]);

            if(output_autocorrelation == 1) { 
                lda_open_write_file_output_autocorrelation(1);
            }

            i++;
        } while(RAA[j] >= 0.001);
    }
   
    

    int_time_steps = j;

    dt_autocorr = lag_step * time_step_mean;
    lag = j-1;
   
}







/************************************************************
* function    : lda_integral_scales                         *
*-----------------------------------------------------------*
* task        : detecting the integral length scale Lux     *               
* parameter   : time series of the autocorrelation          *
*               coefficient RAA (array)                     *
* return value: no one                                      *
************************************************************/

void lda_integral_scales(float array[], float dt, int count)
{
    integral_time = 0.;
    sum_RAA = 0.;
    
    for (i=0; i < count; i++)
    {
        integral_time = integral_time + (dt/2.)*(array[i]+array[i+1]);
        sum_RAA       = sum_RAA + array[i];
    }
    
    integral_time = integral_time + (dt/2.)*(array[i]+0.);

    t_ux = integral_time;
    printf(" Tux: %5.3lf s\n", t_ux);
    l_ux = integral_time * fabs(data_raw_comp1_mean_arith);
    printf(" Lux: %5.3lf m\n", l_ux);
}







/************************************************************
* function    : lda_spectrum                                *
*-----------------------------------------------------------*
* task        : calculating the discrete spectral energies  *
*               for all frequencies                         *               
* parameter   :                                             *
* return value: no one                                      *
************************************************************/

void lda_spectrum(double array[][SIZE], int number, int t_scale, int count, char *component)
{
    int m, n, n_min, c1, c2, c3, c4, c3_width, block_size;
    double z_ref, U_ref, df, sum_fred, sum_fSsigma;
    double inf, sup, diff;


    if (raw_filename_output == 0) {
        sprintf(out_file_spectrum, "SPEC\\%s_%s_%s_%s_%s%s_%s_%s_%s_%s_%scomp_EWTL.spec",
                str_maincamp, str_subcamp, str_wt, str_meastype, str_comp1, str_comp2, str_instnumb, str_winddir, meas_number_string, ts_string, component);
    }
    if (raw_filename_output == 1) {
        sprintf(out_file_spectrum, "SPEC\\%s_%s_EWTL.spec", meas_code, ts_string);
    }        
    fh = fopen(out_file_spectrum, "w");
    

    fprintf(fh, "# EWTL power spectrum derived from LDA time series\n");
    fprintf(fh, "# \n");
    fprintf(fh, "# ********** DATA DESCRIPTION **********\n");
    fprintf(fh, "# \n# \n# \n# \n# \n");
    fprintf(fh, "# ********** GENERAL INFORMATION **********\n");
    fprintf(fh, "# %s [main project name]\n", str_maincamp);
    fprintf(fh, "# %s [sub project name]\n", str_subcamp);
    if (strcmp(str_wt, BLASIUS) == 0) {
        fprintf(fh, "# BLASIUS [wind tunnel facility]\n");
    }
    else if (strcmp(str_wt, WOTAN) == 0) {
        fprintf(fh, "# WOTAN [wind tunnel facility]\n");
    }
    fprintf(fh, "# 1:%i [model - scale]\n", model_scale);
    fprintf(fh, "# %5.2lf [zref - full scale [m]]\n", ref_height*model_scale);
    fprintf(fh, "# %5.2lf [zref - model scale [mm]]\n", ref_height*1000.);
    fprintf(fh, "# %5.2lf [Uref - model [m/s]]\n", u_ref*lda_scale_factor);
    fprintf(fh, "# %5.2lf [approach flow direction []]\n", atof(str_winddir)/10.);
    fprintf(fh, "# 1.0 [Lref - model scale [m]]\n");
    fprintf(fh, "# %i [Lref - full scale [m]]\n", model_scale);
    fprintf(fh, "# # [utm zone]\n");

    if(quality_flag == 0) { 
        fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 1) {
        fprintf(fh, "# \n# ATTENTION: in case of an approach flow measurement,\n");
        fprintf(fh, "#            timeseries is not adequate for boundary layer characterization!\n");
        fprintf(fh, "#            (position below 1.5 height of roughness elements)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 2) {
        fprintf(fh, "# \n# ATTENTION: handle with care,\n");
        fprintf(fh, "#            flow might be out of the prandtl layer!\n");
        fprintf(fh, "#            (position within ]100 m; 150 m] height in full scale)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 3) {
        fprintf(fh, "# \n# ATTENTION: flow is out of the model area (prandtl layer)!\n");
        fprintf(fh, "#            (position above 150 m height in full scale)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n");
    }

    fprintf(fh, "# ********** FLOW MEASUREMENTS **********\n");
    fprintf(fh, "# %s [measurement type]\n", str_meastype);
    fprintf(fh, "# 2 [number of columns]\n");
    fprintf(fh, "# \"f*z/Umean\" \"f*SUU(f,z)/sigmaU^2\" [labels]\n");
    fprintf(fh, "# %s%s [measured components]\n", str_comp1, str_comp2);
    fprintf(fh, "# %5.2lf [measurement location X - model scale [mm]]\n", atof(x_position));  
    fprintf(fh, "# %5.2lf [measurement location Y - model scale [mm]]\n", atof(y_position));  
    fprintf(fh, "# %5.2lf [measurement location Z - model scale [mm]]\n", atof(z_position));  
    fprintf(fh, "# %5.2lf [measurement location X - full scale [m]]\n", (atof(x_position)/1000.)*model_scale);  
    fprintf(fh, "# %5.2lf [measurement location Y - full scale [m]]\n", (atof(y_position)/1000.)*model_scale);  
    fprintf(fh, "# %5.2lf [measurement location Z - full scale [m]]\n", (atof(z_position)/1000.)*model_scale);
    fprintf(fh, "# # [measurement location utm Easting [m]]\n");
    fprintf(fh, "# # [measurement location utm Northing [m]]\n");
    if (strcmp(str_comp1, U_WIND) == 0 && strcmp(str_comp2, V_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {U,V}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }
    if (strcmp(str_comp1, U_WIND) == 0 && strcmp(str_comp2, W_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {U,W}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }
    if (strcmp(str_comp1, V_WIND) == 0 && strcmp(str_comp2, W_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {V,W}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }     
    fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n# \n");

    fprintf(fh, "# ********** CONCENTRATION MEASUREMENTS **********\n");
    fprintf(fh, "# # [measurement type]\n");
    fprintf(fh, "# # [number of columns]\n");
    fprintf(fh, "# # [labels]\n");
    fprintf(fh, "# # [released gas]\n");
    fprintf(fh, "# # [source strength [l/h]]\n");
    fprintf(fh, "# # [release duration [s]]\n");
    fprintf(fh, "# # [number of released puffs]\n");
    fprintf(fh, "# # [number of detected puffs, which dosage exceeds the dosage threshold]\n");
    fprintf(fh, "# # [discard threshold/minimum dosage - model scale [ppmvs] ]\n");
    fprintf(fh, "# # [source location X - model scale [mm]]\n");
    fprintf(fh, "# # [source location Y - model scale [mm]]\n");
    fprintf(fh, "# # [source location Z - model scale [mm]]\n");
    fprintf(fh, "# # [source location X - full scale [m]]\n");
    fprintf(fh, "# # [source location Y - full scale [m]]\n");
    fprintf(fh, "# # [source location Z - full scale [m]]\n");
    fprintf(fh, "# # [source location utm Easting [m]]\n");
    fprintf(fh, "# # [source location utm Northing [m]]\n");
    fprintf(fh, "# # [measurement location X - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location Y - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location Z - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location X - full scale [m]]\n");
    fprintf(fh, "# # [measurement location Y - full scale [m]]\n");
    fprintf(fh, "# # [measurement location Z - full scale [m]]\n");
    fprintf(fh, "# # [measurement location utm Easting [m]]\n");
    fprintf(fh, "# # [measurement location utm Northing [m]]\n");
    fprintf(fh, "# # [1E-6 * confidence intervall [-]]\n");

    fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n");

    fprintf(fh, "# %s [date of measurement]\n", time_stamp);
    fprintf(fh, "# ********** END OF HEADER **********\n");
    
    

     
    fprintf(fh, "Variables = \"n [-]\" \"f [1/s]\" \"fz/U<sub>mean</sub> [-]\" \"fS<sub>UU</sub>(f,z)/<greek>s</greek><sub>U</sub><sup>2</sup> [-]\" \"Kaimal [-]\" \"Simiu, Scanlan [-]\" \"von Karman [-]\"\n");
    if (raw_filename_output == 0) {   
        fprintf(fh, "ZONE T = \"%s_%s_%s_%s_%s_%s_%s_%s_%s_%s_%scomp\"\n",
        str_maincamp, str_subcamp, str_wt, str_meastype, str_comp1, str_comp2, str_instnumb, str_winddir, meas_number_string, ts_string, component);
    }
    if (raw_filename_output == 1) {            
        fprintf(fh, "ZONE T = \"%s_%s\"\n", meas_code, ts_string);
    }
    
    n_min = floor( fabs( ((char_length*PI)/mean_data_resam_2)*data_rate_mean ) );
    
    

    FFT_N = fft_data;
    
    printf(" samples for FFT: %i\n", FFT_N);
    
    
    U_ref = fabs(data_raw_comp1_mean_arith);//fabs(mean_data_resam_2);
    df    = 1/(FFT_N*time_step_mean);


    for(j=0; j<FFT_N; j++)
    {
        X[j] = 0.0;
        Y[j] = 0.0;
        E[j] = 0.0;
    }

        
    k = 0;
    i = 0;
    sum_sigma_2 = 0.;   
    do {
         
        for(j=0; j<FFT_N; j++)
        {
            X[j] = 0.0;
            Y[j] = 0.0;
        }
        
        j=0;
        do {
            X[j] = array[number][j+k];
            j++;
        } while(j<FFT_N);    
    
        ReFFT(X, Y, FFT_N);

        for(j=1; j<FFT_N; j++)
        {
            X[j] = X[j]/FFT_N;
            Y[j] = Y[j]/FFT_N;
        }

        sigma_2 = 0.;
        for(j=1; j<FFT_N; j++)
        {
            sigma_2    = sigma_2 + (pow(X[j], 2.0) + pow(Y[j], 2.0));
            //printf("real: %5.3lf  imaginary: %5.3lf     square_sum: %5.3lf          origin: %5.3lf\n", X[j], Y[j], (pow(X[j], 2.0) + pow(Y[j], 2.0)), array[number][j+k]);
        }
        sum_sigma_2 = sum_sigma_2 + sigma_2;

        
        sum_E = 0.;
        for(j=1; j<=FFT_N/2; j++)
        {
            if(j<FFT_N/2){
                E[j]       = E[j] + (2 * (pow(X[j], 2.0) + pow(Y[j], 2.0)));
            }
            if(j==FFT_N/2){
                E[j]       = E[j] + (pow(X[j], 2.0) + pow(Y[j], 2.0));
            }

            sum_E = sum_E + E[j];
        }

        //printf("sigma_2[%i]: %lf   sum_E[%i]: %lf\n", i, sigma_2, i, sum_E);
        k=k+30;//FFT_N;
        i++;
        
    } while(k+FFT_N<count);


    z_ref = atof(z_position);
    z_ref = z_ref/1000.;

    //printf("!!! z_ref: %lf   U_ref: %lf !!!\n", z_ref, U_ref);
    
    sigma_2 = sum_sigma_2/i;
    sum_E   = sum_E/i;
    //printf("sigma^2: %lf   sum of E: %lf\n", sigma_2, sum_E);

    for(j=1; j<=FFT_N/2; j++)
    {
        E[j]  = E[j]/i;
        f[j]  = j/(FFT_N*time_step_mean);
        S[j]  = E[j]/df;
        //printf("E[j%i]: %lf    S[f%i]: %lf\n", j, E[j], j, S[j]);
    }



    /******************* frequency smoothing *********************/
    exponent = 0.;
    j = 1;
    do {
        if(exponent <= log(MAX_BLOCK)) {
            blocksize = (int) (exp(exponent));
        }
        if(exponent > log(MAX_BLOCK)) {
            blocksize = (int) (MAX_BLOCK);
        }
        k = j;
        E_smooth[j] = 0.;
        S_smooth[j] = 0.;
        /*do {
            E_smooth[j] = E_smooth[j] + E[k];
            S_smooth[j] = S_smooth[j] + S[k];
            k++;
        } while(k<(j+blocksize));*/
        if((j+blocksize)<=FFT_N/2) {
            for(k=j; k<(j+blocksize); k++) {
                E_smooth[j] = E_smooth[j] + E[k];
                S_smooth[j] = S_smooth[j] + S[k];
            }
            E_smooth[j] = E_smooth[j]/blocksize;
            S_smooth[j] = S_smooth[j]/blocksize;
        }
        if((j+blocksize)>FFT_N/2) {
            E_smooth[j] = E_smooth[j] + E[k];
            S_smooth[j] = S_smooth[j] + S[k];
        }
        //printf("S_smooth[%i]: %lf     blocksize: %i\n", j, S_smooth[j], blocksize);
        exponent  = exponent + 0.1;
        j = j + blocksize;
    } while(j<=FFT_N/2);
    /**************************************************************/







    exponent = 0.;
    j = 1;
    do {
        if(exponent <= log(MAX_BLOCK)) {
            blocksize = (int) (exp(exponent));
        }
        if(exponent > log(MAX_BLOCK)) {
            blocksize = (int) (MAX_BLOCK);
        }

        fprintf(fh, "%i   %5.5lf   %5.5lf   %5.5lf   %5.5lf   %5.5lf   %5.5lf\n",
                    j, f[j], f[j]*z_ref/U_ref, f[j]*S_smooth[j]/sigma_2,
                    A_KAIMAL*(f[j]*z_ref/U_ref)/pow(E_KAIMAL+B_KAIMAL*pow((f[j]*z_ref/U_ref), C_KAIMAL), D_KAIMAL),
                    A_SIMIUSCANLAN*(f[j]*z_ref/U_ref)/pow(E_SIMIUSCANLAN+B_SIMIUSCANLAN*pow((f[j]*z_ref/U_ref), C_SIMIUSCANLAN), D_SIMIUSCANLAN),
                    A_KARMAN*(f[j]*z_ref/U_ref)/pow(E_KARMAN+B_KARMAN*pow((f[j]*l_ux/U_ref), C_KARMAN), D_KARMAN));

        exponent = exponent + 0.1;
        j = j + blocksize;
    } while(j<=FFT_N/2);    
        

    close(fh);
    
}












/************************************************************
* function    : lda_fluctuation_time_direction              *
*-----------------------------------------------------------*
* task        : calculating the discrete spectral energies  *
*               for all frequencies                         *               
* parameter   :                                             *
* return value: no one                                      *
************************************************************/

void lda_fluctuation_time_direction()
{
    
    /************* detection of alpha mean times *******************************************************/
    i = 0;
    mean_time_index = 0;
    do {
        if(direction_diff[i] == 0.) {
            mean_time[mean_time_index] = data_raw[0][i];
            mean_time_scaled[mean_time_index] = u_ref*lda_scale_factor*mean_time[mean_time_index]/1.;
            mean_time_index++;
        }
        if(direction_diff[i] != 0.) {
            if(fabs(direction_diff[i+1] - direction_diff[i]) <= 180.) {
                if(direction_diff[i] < 0. && direction_diff[i+1] > 0.) {
                    mean_time[mean_time_index] = data_raw[0][i] + (fabs(direction_diff[i]) * fabs(data_raw[0][i+1] - data_raw[0][i])/fabs(direction_diff[i+1] - direction_diff[i]));
                    mean_time_scaled[mean_time_index] = u_ref*lda_scale_factor*mean_time[mean_time_index]/1.;
                    printf("mean time[%i]: %lf      %lf %lf   %lf %lf\n", mean_time_index, mean_time[mean_time_index], direction_diff[i], direction_diff[i+1], data_raw[0][i], data_raw[0][i+1]);
                    mean_time_index++;
                }
                if(direction_diff[i] > 0. && direction_diff[i+1] < 0.) {
                    mean_time[mean_time_index] = data_raw[0][i+1] - (fabs(direction_diff[i+1]) * fabs(data_raw[0][i+1] - data_raw[0][i])/fabs(direction_diff[i] - direction_diff[i+1]));
                    mean_time_scaled[mean_time_index] = u_ref*lda_scale_factor*mean_time[mean_time_index]/1.;
                    printf("mean time[%i]: %lf      %lf %lf   %lf %lf\n", mean_time_index, mean_time[mean_time_index], direction_diff[i], direction_diff[i+1], data_raw[0][i], data_raw[0][i+1]);
                    mean_time_index++;
                }
            }
        }
        i++;
    } while (i < data_count[0]);
    
    mean_time_index_max = mean_time_index-1;
    printf("mean_time_index_max: %i\n", mean_time_index_max);
    /*********************************************************************************************************/

    angle_index = 0;
    angle[0] = 360./classnumber_direction;

    do {
        i = 0;
        mean_time_index = 0;
        do {
            if(data_raw[0][i] > mean_time[mean_time_index]) {
                count = 0;
                do {
                    success = 0;
                    if(data_raw[0][i+count] > mean_time[mean_time_index] && fabs(direction_diff[i+count]) >= angle[angle_index]) {
                        if(fabs(direction_diff[i+count]) == angle[angle_index]) {
                            angle_time[angle_index][mean_time_index] = data_raw[0][i+count] - mean_time[mean_time_index];
                            angle_time_scaled[angle_index][mean_time_index] = u_ref*lda_scale_factor*angle_time[angle_index][mean_time_index]/1.;
                            printf("angle_time[%i][%i]: %lf       %lf  %lf    %i    1\n", angle_index, mean_time_index, angle_time[angle_index][mean_time_index], data_raw[0][i+count], mean_time[mean_time_index], i+count);
                        }
                        if(fabs(direction_diff[i+count]) > angle[angle_index] && data_raw[0][i+count-1] > mean_time[mean_time_index]) {
                            angle_time[angle_index][mean_time_index] = (data_raw[0][i+count-1] - mean_time[mean_time_index]) + fabs(angle[angle_index]-direction_diff[i+count-1])*fabs(data_raw[0][i+count]-data_raw[0][i+count-1])/fabs(direction_diff[i+count]-direction_diff[i+count-1]);
                            angle_time_scaled[angle_index][mean_time_index] = u_ref*lda_scale_factor*angle_time[angle_index][mean_time_index]/1.;
                            printf("angle_time[%i][%i]: %lf       %lf  %lf    %i    2\n", angle_index, mean_time_index, angle_time[angle_index][mean_time_index], data_raw[0][i+count], mean_time[mean_time_index], i+count);
                        }
                        if(fabs(direction_diff[i+count]) > angle[angle_index] && data_raw[0][i+count-1] < mean_time[mean_time_index]) {
                            angle_time[angle_index][mean_time_index] = fabs(angle[angle_index])*fabs(data_raw[0][i+count]-mean_time[mean_time_index])/fabs(direction_diff[i+count]);
                            angle_time_scaled[angle_index][mean_time_index] = u_ref*lda_scale_factor*angle_time[angle_index][mean_time_index]/1.;
                            printf("angle_time[%i][%i]: %lf       %lf  %lf    %i    3\n", angle_index, mean_time_index, angle_time[angle_index][mean_time_index], data_raw[0][i+count], mean_time[mean_time_index], i+count);
                        }
                    
                        sum_angle_time[angle_index]        = sum_angle_time[angle_index] + angle_time[angle_index][mean_time_index];
                        sum_angle_time_scaled[angle_index] = sum_angle_time_scaled[angle_index] + angle_time_scaled[angle_index][mean_time_index];
                        angle_count[angle_index]++;
                        mean_time_index++;
                        success = 1;
                    }
                    count++;
                } while (success == 0 && i+count < data_count[0]);
            }
            i++;
        } while (i < data_count[0]);
        angle_index++;
        angle[angle_index] = angle[angle_index-1] + 360./classnumber_direction;
    } while (angle[angle_index] <= 180.);
    /*angle_index = 0;
    angle[0]    = 360./classnumber_direction;
    do {
        mean_time_index = 0;
        angle_count[angle_index] = 0;
        sum_angle_time[angle_index] = 0.;
        sum_angle_time_scaled[angle_index] = 0.;
        do {
            success = 0;
            for (i = 0; i < data_count[0]; i++) {
                if(data_raw[0][i] > mean_time[mean_time_index] && fabs(direction_diff[i]) >= angle[angle_index] && success == 0) {
                    if(fabs(direction_diff[i]) == angle[angle_index]) {
                        angle_time[angle_index][mean_time_index] = data_raw[0][i] - mean_time[mean_time_index];
                        angle_time_scaled[angle_index][mean_time_index] = u_ref*lda_scale_factor*angle_time[angle_index][mean_time_index]/1.;
                        //printf("angle_time[%i][%i]: %lf       %lf  %lf    %i    1\n", angle_index, mean_time_index, angle_time[angle_index][mean_time_index], data_raw[0][i], mean_time[mean_time_index], i);
                    }
                    if(fabs(direction_diff[i]) > angle[angle_index] && data_raw[0][i-1] > mean_time[mean_time_index]) {
                        angle_time[angle_index][mean_time_index] = (data_raw[0][i-1] - mean_time[mean_time_index]) + fabs(angle[angle_index]-direction_diff[i-1])*fabs(data_raw[0][i]-data_raw[0][i-1])/fabs(direction_diff[i]-direction_diff[i-1]);
                        angle_time_scaled[angle_index][mean_time_index] = u_ref*lda_scale_factor*angle_time[angle_index][mean_time_index]/1.;
                        //printf("angle_time[%i][%i]: %lf       %lf  %lf    %i    2\n", angle_index, mean_time_index, angle_time[angle_index][mean_time_index], data_raw[0][i], mean_time[mean_time_index], i);
                    }
                    if(fabs(direction_diff[i]) > angle[angle_index] && data_raw[0][i-1] < mean_time[mean_time_index]) {
                        angle_time[angle_index][mean_time_index] = fabs(angle[angle_index])*fabs(data_raw[0][i]-mean_time[mean_time_index])/fabs(direction_diff[i]);
                        angle_time_scaled[angle_index][mean_time_index] = u_ref*lda_scale_factor*angle_time[angle_index][mean_time_index]/1.;
                        //printf("angle_time[%i][%i]: %lf       %lf  %lf    %i    3\n", angle_index, mean_time_index, angle_time[angle_index][mean_time_index], data_raw[0][i], mean_time[mean_time_index], i);
                    }
                    
                    sum_angle_time[angle_index]        = sum_angle_time[angle_index] + angle_time[angle_index][mean_time_index];
                    sum_angle_time_scaled[angle_index] = sum_angle_time_scaled[angle_index] + angle_time_scaled[angle_index][mean_time_index];
                    angle_count[angle_index]++;
                    success = 1;
                }
            }
            mean_time_index++;
        } while (mean_time_index <= mean_time_index_max);

        mean_angle_time[angle_index]        = sum_angle_time[angle_index]/mean_time_index_max;
        mean_angle_time_scaled[angle_index] = sum_angle_time_scaled[angle_index]/mean_time_index_max;

        printf("angle[%i]: %lf      %lf\n", angle_index, angle[angle_index], mean_angle_time[angle_index]);
        
        angle_index++;
        angle[angle_index] = angle[angle_index-1] + 360./classnumber_direction;
    } while (angle[angle_index] <= 180.);

    angle_index_max = angle_index-1;*/


    for (angle_index = 0; angle_index <= angle_index_max; angle_index++) {
        printf("angle[%i]: %lf   angle time[%i]: %lf   data[%i]: %i\n", angle_index, angle[angle_index], angle_index, mean_angle_time[angle_index], angle_index, angle_count[angle_index]);
    }




    if (raw_filename_output == 0) {
        sprintf(out_file_deflection_time, "DEFTIME\\%s_%s_%s_%s_%s%s_%s_%s_%s_%s_EWTL.deft",
                str_maincamp, str_subcamp, str_wt, str_meastype, str_comp1, str_comp2, str_instnumb, str_winddir, meas_number_string, ts_string);
    }
    if (raw_filename_output == 1) {
        sprintf(out_file_deflection_time, "DEFTIME\\%s_%s_EWTL.deftime", meas_code, ts_string);
    }        
    fh = fopen(out_file_deflection_time, "w");
    
    
    fprintf(fh, "# EWTL deflection times from mean wind direction derived from LDA time series\n");
    fprintf(fh, "# \n");
    fprintf(fh, "# ********** DATA DESCRIPTION **********\n");
    fprintf(fh, "# \n# \n# \n# \n# \n");
    fprintf(fh, "# ********** GENERAL INFORMATION **********\n");
    fprintf(fh, "# %s [main project name]\n", str_maincamp);
    fprintf(fh, "# %s [sub project name]\n", str_subcamp);
    if (strcmp(str_wt, BLASIUS) == 0) {
        fprintf(fh, "# BLASIUS [wind tunnel facility]\n");
    }
    else if (strcmp(str_wt, WOTAN) == 0) {
        fprintf(fh, "# WOTAN [wind tunnel facility]\n");
    }
    fprintf(fh, "# 1:%i [model - scale]\n", model_scale);
    fprintf(fh, "# %5.2lf [zref - full scale [m]]\n", ref_height*model_scale);
    fprintf(fh, "# %5.2lf [zref - model scale [mm]]\n", ref_height*1000.);
    fprintf(fh, "# %5.2lf [Uref - model [m/s]]\n", u_ref*lda_scale_factor);
    fprintf(fh, "# %5.2lf [approach flow direction []]\n", atof(str_winddir)/10.);
    fprintf(fh, "# 1.0 [Lref - model scale [m]]\n");
    fprintf(fh, "# %i [Lref - full scale [m]]\n", model_scale);
    fprintf(fh, "# # [utm zone]\n");

    if(quality_flag == 0) { 
        fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 1) {
        fprintf(fh, "# \n# ATTENTION: in case of an approach flow measurement,\n");
        fprintf(fh, "#            timeseries is not adequate for boundary layer characterization!\n");
        fprintf(fh, "#            (position below 1.5 height of roughness elements)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 2) {
        fprintf(fh, "# \n# ATTENTION: handle with care,\n");
        fprintf(fh, "#            flow might be out of the prandtl layer!\n");
        fprintf(fh, "#            (position within ]100 m; 150 m] height in full scale)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 3) {
        fprintf(fh, "# \n# ATTENTION: flow is out of the model area (prandtl layer)!\n");
        fprintf(fh, "#            (position above 150 m height in full scale)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n");
    }

    fprintf(fh, "# ********** FLOW MEASUREMENTS **********\n");
    fprintf(fh, "# %s [measurement type]\n", str_meastype);
    fprintf(fh, "# 2 [number of columns]\n");
    fprintf(fh, "# \"deviation in %s-direction\" \"normalized frequency of occurence\" [labels]\n", str_comp2);
    fprintf(fh, "# %s%s [measured components]\n", str_comp1, str_comp2);
    fprintf(fh, "# %5.2lf [measurement location X - model scale [mm]]\n", atof(x_position));  
    fprintf(fh, "# %5.2lf [measurement location Y - model scale [mm]]\n", atof(y_position));  
    fprintf(fh, "# %5.2lf [measurement location Z - model scale [mm]]\n", atof(z_position));  
    fprintf(fh, "# %5.2lf [measurement location X - full scale [m]]\n", (atof(x_position)/1000.)*model_scale);  
    fprintf(fh, "# %5.2lf [measurement location Y - full scale [m]]\n", (atof(y_position)/1000.)*model_scale);  
    fprintf(fh, "# %5.2lf [measurement location Z - full scale [m]]\n", (atof(z_position)/1000.)*model_scale);
    fprintf(fh, "# # [measurement location utm Easting [m]]\n");
    fprintf(fh, "# # [measurement location utm Northing [m]]\n");
    if (strcmp(str_comp1, U_WIND) == 0 && strcmp(str_comp2, V_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {U,V}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }
    if (strcmp(str_comp1, U_WIND) == 0 && strcmp(str_comp2, W_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {U,W}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }
    if (strcmp(str_comp1, V_WIND) == 0 && strcmp(str_comp2, W_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {V,W}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }   
    fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n# \n");

    fprintf(fh, "# ********** CONCENTRATION MEASUREMENTS **********\n");
    fprintf(fh, "# # [measurement type]\n");
    fprintf(fh, "# # [number of columns]\n");
    fprintf(fh, "# # [labels]\n");
    fprintf(fh, "# # [released gas]\n");
    fprintf(fh, "# # [source strength [l/h]]\n");
    fprintf(fh, "# # [release duration [s]]\n");
    fprintf(fh, "# # [number of released puffs]\n");
    fprintf(fh, "# # [number of detected puffs, which dosage exceeds the dosage threshold]\n");
    fprintf(fh, "# # [discard threshold/minimum dosage - model scale [ppmvs] ]\n");
    fprintf(fh, "# # [source location X - model scale [mm]]\n");
    fprintf(fh, "# # [source location Y - model scale [mm]]\n");
    fprintf(fh, "# # [source location Z - model scale [mm]]\n");
    fprintf(fh, "# # [source location X - full scale [m]]\n");
    fprintf(fh, "# # [source location Y - full scale [m]]\n");
    fprintf(fh, "# # [source location Z - full scale [m]]\n");
    fprintf(fh, "# # [source location utm Easting [m]]\n");
    fprintf(fh, "# # [source location utm Northing [m]]\n");
    fprintf(fh, "# # [measurement location X - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location Y - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location Z - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location X - full scale [m]]\n");
    fprintf(fh, "# # [measurement location Y - full scale [m]]\n");
    fprintf(fh, "# # [measurement location Z - full scale [m]]\n");
    fprintf(fh, "# # [measurement location utm Easting [m]]\n");
    fprintf(fh, "# # [measurement location utm Northing [m]]\n");
    fprintf(fh, "# # [1E-6 * confidence intervall [-]]\n");

    fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n");

    fprintf(fh, "# %s [date of measurement]\n", time_stamp);
    fprintf(fh, "# ********** END OF HEADER **********\n");
    

     
    fprintf(fh, "Variables = \"deflection[]\" \"t<sup>*</sup> [-]\" \"t [s]\" \"number of input data [-]\"\n");
    if (raw_filename_output == 0) {
        fprintf(fh, "ZONE T = \"%s_%s_%s_%s_%s_%s_%s_%s_%s_%s\"\n",
        str_maincamp, str_subcamp, str_wt, str_meastype, str_comp1, str_comp2, str_instnumb, str_winddir, meas_number_string, ts_string);
    }
    if (raw_filename_output == 1) {            
        fprintf(fh, "ZONE T = \"%s_%s\"\n", meas_code, ts_string);
    }
        
    for (angle_index = 0; angle_index <= angle_index_max; angle_index++) {
        if(mean_angle_time[angle_index] != 0.) {
            fprintf(fh, "%lf %lf %lf %i\n", angle[angle_index], mean_angle_time_scaled[angle_index], mean_angle_time[angle_index], angle_count[angle_index]);
        }
    }
        
    close(fh);
    
}











    

/************************************************************
* function    : lda_wind_fluctuation                        *
*-----------------------------------------------------------*
* task        : calculating the discrete spectral energies  *
*               for all frequencies                         *               
* parameter   :                                             *
* return value: no one                                      *
************************************************************/

void lda_wind_fluctuation(double array[][SIZE], int number1, int number2)
{
    int class, class_max;
    double inf, sup, class_center;

    //i = 0;
    //sum_comp1 = 0.;
    //sum_comp2 = 0.;
    //do {
    //    sum_comp1 = sum_comp1 + array[number1][i];
    //    sum_comp2 = sum_comp2 + array[number2][i];
    //    i++;
    //} while(i < data_count[0]);
    //mean_comp1 = sum_comp1/data_count[0];
    //mean_comp2 = sum_comp2/data_count[0];

    //mean_direction = atan2(sum_comp2, sum_comp1) * (360./(2*PI));
    //mean_length    = sqrt(pow(mean_comp1, 2.0) + pow(mean_comp2, 2.0));

                                                                                      i = 0;
                                                                                      do {
                                                                                          direction[i] = atan2(array[number2][i], array[number1][i]) * (360./(2.*PI));
                                                                                          norm[i]      = sqrt(pow(array[number2][i], 2.0) + pow(array[number1][i], 2.0));
                                                                                          i++;
                                                                                      } while(i < data_count[0]);

                                                                                      sum_direction = 0.0;
                                                                                      i = 0;
                                                                                      do {
                                                                                          sum_direction = sum_direction + direction[i];
                                                                                          i++;
                                                                                      } while(i < data_count[0]);

                                                                                      mean_direction = sum_direction/data_count[0];

                                                                                      printf(" mean winddirection: %3.2lf\n", mean_direction);
                                                                                      

   
    

    i = 0;
    sum_diff = 0.;
    sum_diff_weight = 0.;
    do {
        direction_diff[i] = direction[i] - mean_direction;
        if(direction_diff[i] < -180.) {
            direction_diff[i] = direction_diff[i] + 360.;
        }
        if(direction_diff[i] >= 180.) {
            direction_diff[i] = direction_diff[i] - 360.;
        }
        sum_diff        = sum_diff        + direction_diff[i];
        sum_diff_weight = sum_diff_weight + (direction_diff[i] * weight_fac[i]);
        
        printf(" delta: %3.2lf\n", direction_diff[i]);
                                                                                      
        i++;
    } while(i < data_count[0]);

    classwidth_direction = 360./classnumber_direction;
    


    inf = -180.;
    sup = inf + classwidth_direction;
    class = 1;
    
    do {
        i = 0;
        freq_abs_dir[class]         = 0;
        freq_abs_diff[class]        = 0;
        freq_abs_diff_weight[class] = 0.; 
        do {
            if(direction[i] >= inf && direction[i] < sup) {
                freq_abs_dir[class]++;
            }
            if(direction_diff[i] >= inf && direction_diff[i] < sup) {
                freq_abs_diff[class]++;
                freq_abs_diff_weight[class] = freq_abs_diff_weight[class] + (1. * weight_fac[i]);
            }
            i++;
        } while(i < data_count[0]);
        inf = inf + classwidth_direction;
        sup = sup + classwidth_direction;
        class++;
    } while(sup <= 180.);

    class_max = class - 1;




    i = 0;
    do {
        direction_new[i] = direction[i] + (atof(str_winddir)/10.);
        if(direction_new[i] < 0.) {
            direction_new[i] = direction_new[i] + 360.;
        }
        if(direction_new[i] >= 360.) {
            direction_new[i] = direction_new[i] - 360.;
        }
        //printf("Richtung (alt):%5.1lf   Richtung (neu):%5.1lf\n", direction[i], direction_new[i]);
        i++;
    } while(i < data_count[0]);


    
    inf = 0.;
    sup = inf + classwidth_direction;
    class = 1;

    do {
        i = 0;
        freq_abs_dir_new[class] = 0;
        do {
            if(direction_new[i] >= inf && direction_new[i] < sup) {
                freq_abs_dir_new[class]++;
            }
            i++;
        } while(i < data_count[0]);
        inf = inf + classwidth_direction;
        sup = sup + classwidth_direction;
        class++;
    } while(sup <= 360.);



    if (raw_filename_output == 0) {
        sprintf(out_file_fluctuations, "FLUC_direction\\%s_%s_%s_%s_%s%s_%s_%s_%s_%s_EWTL.fluc",
                str_maincamp, str_subcamp, str_wt, str_meastype, str_comp1, str_comp2, str_instnumb, str_winddir, meas_number_string, ts_string);
    }
    if (raw_filename_output == 1) {
        sprintf(out_file_fluctuations, "FLUC_direction\\%s_%s_EWTL.fluc", meas_code, ts_string);
    }        
    fh = fopen(out_file_fluctuations, "w");
    

    
    fprintf(fh, "# EWTL fluctuations of wind direction derived from LDA time series\n");
    fprintf(fh, "# \n");
    fprintf(fh, "# ********** DATA DESCRIPTION **********\n");
    fprintf(fh, "# \n# \n# \n# \n# \n");
    fprintf(fh, "# ********** GENERAL INFORMATION **********\n");
    fprintf(fh, "# %s [main project name]\n", str_maincamp);
    fprintf(fh, "# %s [sub project name]\n", str_subcamp);
    if (strcmp(str_wt, BLASIUS) == 0) {
        fprintf(fh, "# BLASIUS [wind tunnel facility]\n");
    }
    else if (strcmp(str_wt, WOTAN) == 0) {
        fprintf(fh, "# WOTAN [wind tunnel facility]\n");
    }
    fprintf(fh, "# 1:%i [model - scale]\n", model_scale);
    fprintf(fh, "# %5.2lf [zref - full scale [m]]\n", ref_height*model_scale);
    fprintf(fh, "# %5.2lf [zref - model scale [mm]]\n", ref_height*1000.);
    fprintf(fh, "# %5.2lf [Uref - model [m/s]]\n", u_ref*lda_scale_factor);
    fprintf(fh, "# %5.2lf [approach flow direction []]\n", atof(str_winddir)/10.);
    fprintf(fh, "# 1.0 [Lref - model scale [m]]\n");
    fprintf(fh, "# %i [Lref - full scale [m]]\n", model_scale);
    fprintf(fh, "# # [utm zone]\n");

    if(quality_flag == 0) { 
        fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 1) {
        fprintf(fh, "# \n# ATTENTION: in case of an approach flow measurement,\n");
        fprintf(fh, "#            timeseries is not adequate for boundary layer characterization!\n");
        fprintf(fh, "#            (position below 1.5 height of roughness elements)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 2) {
        fprintf(fh, "# \n# ATTENTION: handle with care,\n");
        fprintf(fh, "#            flow might be out of the prandtl layer!\n");
        fprintf(fh, "#            (position within ]100 m; 150 m] height in full scale)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n");
    }
    if(quality_flag == 3) {
        fprintf(fh, "# \nATTENTION: flow is out of the model area (prandtl layer)!\n");
        fprintf(fh, "#            (position above 150 m height in full scale)\n");
        fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n");
    }

    fprintf(fh, "# ********** FLOW MEASUREMENTS **********\n");
    fprintf(fh, "# %s [measurement type]\n", str_meastype);
    fprintf(fh, "# 2 [number of columns]\n");
    fprintf(fh, "# \"deviation in %s-direction\" \"normalized frequency of occurence\" [labels]\n", str_comp2);
    fprintf(fh, "# %s%s [measured components]\n", str_comp1, str_comp2);
    fprintf(fh, "# %5.2lf [measurement location X - model scale [mm]]\n", atof(x_position));  
    fprintf(fh, "# %5.2lf [measurement location Y - model scale [mm]]\n", atof(y_position));  
    fprintf(fh, "# %5.2lf [measurement location Z - model scale [mm]]\n", atof(z_position));  
    fprintf(fh, "# %5.2lf [measurement location X - full scale [m]]\n", (atof(x_position)/1000.)*model_scale);  
    fprintf(fh, "# %5.2lf [measurement location Y - full scale [m]]\n", (atof(y_position)/1000.)*model_scale);  
    fprintf(fh, "# %5.2lf [measurement location Z - full scale [m]]\n", (atof(z_position)/1000.)*model_scale);
    fprintf(fh, "# # [measurement location utm Easting [m]]\n");
    fprintf(fh, "# # [measurement location utm Northing [m]]\n");
    if (strcmp(str_comp1, U_WIND) == 0 && strcmp(str_comp2, V_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {U,V}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }
    if (strcmp(str_comp1, U_WIND) == 0 && strcmp(str_comp2, W_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {U,W}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }
    if (strcmp(str_comp1, V_WIND) == 0 && strcmp(str_comp2, W_WIND) == 0) {   
        fprintf(fh, "# %5.3lf %5.3lf [confidence intervall {V,W}/Uref[-]]\n", reproducibility_comp1, reproducibility_comp2);
    }   
    fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n# \n");

    fprintf(fh, "# ********** CONCENTRATION MEASUREMENTS **********\n");
    fprintf(fh, "# # [measurement type]\n");
    fprintf(fh, "# # [number of columns]\n");
    fprintf(fh, "# # [labels]\n");
    fprintf(fh, "# # [released gas]\n");
    fprintf(fh, "# # [source strength [l/h]]\n");
    fprintf(fh, "# # [release duration [s]]\n");
    fprintf(fh, "# # [number of released puffs]\n");
    fprintf(fh, "# # [number of detected puffs, which dosage exceeds the dosage threshold]\n");
    fprintf(fh, "# # [discard threshold/minimum dosage - model scale [ppmvs] ]\n");
    fprintf(fh, "# # [source location X - model scale [mm]]\n");
    fprintf(fh, "# # [source location Y - model scale [mm]]\n");
    fprintf(fh, "# # [source location Z - model scale [mm]]\n");
    fprintf(fh, "# # [source location X - full scale [m]]\n");
    fprintf(fh, "# # [source location Y - full scale [m]]\n");
    fprintf(fh, "# # [source location Z - full scale [m]]\n");
    fprintf(fh, "# # [source location utm Easting [m]]\n");
    fprintf(fh, "# # [source location utm Northing [m]]\n");
    fprintf(fh, "# # [measurement location X - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location Y - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location Z - model scale [mm]]\n");
    fprintf(fh, "# # [measurement location X - full scale [m]]\n");
    fprintf(fh, "# # [measurement location Y - full scale [m]]\n");
    fprintf(fh, "# # [measurement location Z - full scale [m]]\n");
    fprintf(fh, "# # [measurement location utm Easting [m]]\n");
    fprintf(fh, "# # [measurement location utm Northing [m]]\n");
    fprintf(fh, "# # [1E-6 * confidence intervall [-]]\n");

    fprintf(fh, "# \n# \n# \n# \n# \n# \n# \n# \n");

    fprintf(fh, "# %s [date of measurement]\n", time_stamp);
    fprintf(fh, "# ********** END OF HEADER **********\n");
    
    

        
    fprintf(fh, "Variables = \"classnumber[-]\" \"%s%s-wind direction (I) []\" \"deviation in %s-direction []\" \"%s%s-wind direction (II) []\" \"occurrence (I) [-]\" \"occurrence normalized (I) [-]\" \"occurrence delta [-]\" \"occurrence delta normalized [-]\" \"occurrence (II)\" \"occurrence normalized (II) [-]\"\n", str_comp1, str_comp2, str_comp2, str_comp1, str_comp2);
    if (raw_filename_output == 0) { 
        fprintf(fh, "ZONE T = \"%s_%s_%s_%s_%s_%s_%s_%s_%s_%s\"\n",
        str_maincamp, str_subcamp, str_wt, str_meastype, str_comp1, str_comp2, str_instnumb, str_winddir, meas_number_string, ts_string);
    }
    if (raw_filename_output == 1) {            
        fprintf(fh, "ZONE T = \"%s_%s\"\n", meas_code, ts_string);
    }


    
    class = 1;
    class_center1 = -180. + (classwidth_direction/2.);
    class_center2 = 0. + (classwidth_direction/2.);
    
    do {
        fprintf(fh, "%i  %5.1lf  %5.1lf  %5.1lf %5.0lf  %5.4lf %5.0lf  %5.4lf %5.0lf  %5.4lf\n", class, class_center1, class_center1, class_center2, freq_abs_dir[class], freq_abs_dir[class]/data_count[0], freq_abs_diff[class], freq_abs_diff[class]/data_count[0], freq_abs_dir_new[class], freq_abs_dir_new[class]/data_count[0]);
            
        class++;
        class_center1 = class_center1 + classwidth_direction;
        class_center2 = class_center2 + classwidth_direction;
    } while(class <= class_max);

    close(fh);


    
    //for (i = 0; i < data_count[0]; i++) {
      //  printf("direction[%i]: %lf   1st comp[%i]: %lf   2nd comp[%i]: %lf\n", i, direction[i], i, array[number1][i], i, array[number2][i]);
    //}
}    




























































































