// cc_analysis_input
// created: 02-04-2011
// author:  RF
// last modification: 02-04-2011







void open_timeseries() {
    
    /*************** OPENING INPUT-FILE ***********/

    if((input_file_ptr = fopen(input_file,"r")) == NULL) {
       printf("\n Opening input-file %s aborted!\n", input_file);
       system("PAUSE");
       exit(1);
    }
    else {
        printf("\n Input-file %s has been opened!\n", input_file);
    }

    /***********************************************/
}







void load_timeseries() {
    
    /*************** LOADING TIMESERIES ************/

    //printf("\n\n... loading time series!\n");
    count = 0;
    SUM_UPT = 0.0;
    while (fgets(dummys, sizeof(dummys), input_file_ptr) != NULL)
    {
        sscanf(dummys, "%lf %lf %lf %lf %lf %lf\n",
               &tt[count], &upt[count], &cb[count], &c[count], &trig[count],
               &qsource[count]);        

        SUM_UPT    = SUM_UPT + upt[count];
        SUM_QSOURCE = SUM_QSOURCE + qsource[count];
        
     
        //printf("count: %i\n", count);
        count++;
    }
    
    samples = count;
    U_ref   = (SUM_UPT*scale_factor)/(count-1);
    Qsource = SUM_QSOURCE/(count-1);

    printf(" time series loaded!\n\n");
    printf(" U (prandtl-tube): %5.2lf m/s    ", U_ref/scale_factor);
    printf(" U (reference): %5.2lf m/s\n\n", U_ref);
    printf(" samples: %i\n\n", samples);
    
    /************************************************/
}







void calc_cef() {
    for(count = 0; count < samples; count++) {
        cef[count]  = c[count]-cb[count];
    }
}





























