# EWTL power spectrum derived from LDA time series
# 
# ********** DATA DESCRIPTION **********
# 
# 
# 
# 
# 
# ********** GENERAL INFORMATION **********
# EVALU [main project name]
# PROG [sub project name]
# WOTAN [wind tunnel facility]
# 1:225 [model - scale]
# 100.00 [zref - full scale [m]]
# 444.44 [zref - model scale [mm]]
#  5.40 [Uref - model [m/s]]
# 270.00 [approach flow direction []]
# 1.0 [Lref - model scale [m]]
# 225 [Lref - full scale [m]]
# # [utm zone]
# 
# 
# 
# 
# 
# 
# 
# 
# 
# 
# ********** FLOW MEASUREMENTS **********
# FL [measurement type]
# 2 [number of columns]
# "f*z/Umean" "f*SUU(f,z)/sigmaU^2" [labels]
# UV [measured components]
# 510.30 [measurement location X - model scale [mm]]
# 616.70 [measurement location Y - model scale [mm]]
# 400.00 [measurement location Z - model scale [mm]]
# 114.82 [measurement location X - full scale [m]]
# 138.76 [measurement location Y - full scale [m]]
# 90.00 [measurement location Z - full scale [m]]
# # [measurement location utm Easting [m]]
# # [measurement location utm Northing [m]]
# 0.034 0.029 [confidence intervall {U,V}/Uref[-]]
# 
# 
# 
# 
# 
# 
# 
# 
# 
# 
# ********** CONCENTRATION MEASUREMENTS **********
# # [measurement type]
# # [number of columns]
# # [labels]
# # [released gas]
# # [source strength [l/h]]
# # [release duration [s]]
# # [number of released puffs]
# # [number of detected puffs, which dosage exceeds the dosage threshold]
# # [discard threshold/minimum dosage - model scale [ppmvs] ]
# # [source location X - model scale [mm]]
# # [source location Y - model scale [mm]]
# # [source location Z - model scale [mm]]
# # [source location X - full scale [m]]
# # [source location Y - full scale [m]]
# # [source location Z - full scale [m]]
# # [source location utm Easting [m]]
# # [source location utm Northing [m]]
# # [measurement location X - model scale [mm]]
# # [measurement location Y - model scale [mm]]
# # [measurement location Z - model scale [mm]]
# # [measurement location X - full scale [m]]
# # [measurement location Y - full scale [m]]
# # [measurement location Z - full scale [m]]
# # [measurement location utm Easting [m]]
# # [measurement location utm Northing [m]]
# # [1E-6 * confidence intervall [-]]
# 
# 
# 
# 
# 
# 
# 
# 
# 10:15:58 [date of measurement]
# ********** END OF HEADER **********
Variables = "n [-]" "f [1/s]" "fz/U<sub>mean</sub> [-]" "fS<sub>UU</sub>(f,z)/<greek>s</greek><sub>U</sub><sup>2</sup> [-]" "Kaimal [-]" "Simiu, Scanlan [-]" "von Karman [-]"
ZONE T = "EVALU_PROG_W_FL_U_V_LDA01_2700_001_01_Ucomp"
1   1.25000   0.09459   0.27054   0.14999   0.16499   0.06022
2   2.50000   0.18919   0.50020   0.11722   0.12102   0.04076
3   3.75000   0.28378   0.73009   0.09676   0.09748   0.03154
4   5.00000   0.37837   0.12324   0.08319   0.08272   0.02617
5   6.25000   0.47297   0.43972   0.07350   0.07250   0.02260
6   7.50000   0.56756   0.30435   0.06619   0.06493   0.02004
7   8.75000   0.66216   0.41361   0.06045   0.05907   0.01810
8   10.00000   0.75675   0.05942   0.05581   0.05437   0.01657
