# EWTL power spectrum derived from LDA time series
# 
# ********** DATA DESCRIPTION **********
# 
# 
# 
# 
# 
# ********** GENERAL INFORMATION **********
# EVALU [main project name]
# PROG [sub project name]
# WOTAN [wind tunnel facility]
# 1:225 [model - scale]
# 100.00 [zref - full scale [m]]
# 444.44 [zref - model scale [mm]]
#  5.40 [Uref - model [m/s]]
# 270.00 [approach flow direction []]
# 1.0 [Lref - model scale [m]]
# 225 [Lref - full scale [m]]
# # [utm zone]
# 
# 
# 
# 
# 
# 
# 
# 
# 
# 
# ********** FLOW MEASUREMENTS **********
# FL [measurement type]
# 2 [number of columns]
# "f*z/Umean" "f*SUU(f,z)/sigmaU^2" [labels]
# UV [measured components]
# 510.30 [measurement location X - model scale [mm]]
# 616.70 [measurement location Y - model scale [mm]]
# 400.00 [measurement location Z - model scale [mm]]
# 114.82 [measurement location X - full scale [m]]
# 138.76 [measurement location Y - full scale [m]]
# 90.00 [measurement location Z - full scale [m]]
# # [measurement location utm Easting [m]]
# # [measurement location utm Northing [m]]
# 0.034 0.029 [confidence intervall {U,V}/Uref[-]]
# 
# 
# 
# 
# 
# 
# 
# 
# 
# 
# ********** CONCENTRATION MEASUREMENTS **********
# # [measurement type]
# # [number of columns]
# # [labels]
# # [released gas]
# # [source strength [l/h]]
# # [release duration [s]]
# # [number of released puffs]
# # [number of detected puffs, which dosage exceeds the dosage threshold]
# # [discard threshold/minimum dosage - model scale [ppmvs] ]
# # [source location X - model scale [mm]]
# # [source location Y - model scale [mm]]
# # [source location Z - model scale [mm]]
# # [source location X - full scale [m]]
# # [source location Y - full scale [m]]
# # [source location Z - full scale [m]]
# # [source location utm Easting [m]]
# # [source location utm Northing [m]]
# # [measurement location X - model scale [mm]]
# # [measurement location Y - model scale [mm]]
# # [measurement location Z - model scale [mm]]
# # [measurement location X - full scale [m]]
# # [measurement location Y - full scale [m]]
# # [measurement location Z - full scale [m]]
# # [measurement location utm Easting [m]]
# # [measurement location utm Northing [m]]
# # [1E-6 * confidence intervall [-]]
# 
# 
# 
# 
# 
# 
# 
# 
# 10:15:58 [date of measurement]
# ********** END OF HEADER **********
Variables = "n [-]" "f [1/s]" "fz/U<sub>mean</sub> [-]" "fS<sub>UU</sub>(f,z)/<greek>s</greek><sub>U</sub><sup>2</sup> [-]" "Kaimal [-]" "Simiu, Scanlan [-]" "von Karman [-]"
ZONE T = "EVALU_PROG_W_FL_U_V_LDA01_2700_001_01_Ucomp"
1   1.18750   0.09059   0.53170   0.15166   0.16766   0.05484
2   2.37500   0.18118   0.24539   0.11943   0.12369   0.03696
3   3.56250   0.27176   0.36432   0.09889   0.09985   0.02858
4   4.75000   0.36235   0.30627   0.08516   0.08483   0.02370
5   5.93750   0.45294   0.16728   0.07532   0.07440   0.02047
6   7.12500   0.54353   0.24058   0.06787   0.06666   0.01815
7   8.31250   0.63411   0.32938   0.06202   0.06067   0.01639
8   9.50000   0.72470   0.21594   0.05728   0.05585   0.01500
